unit fMHA7_Summary;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  ExtCtrls,
  fIA_dialogs, Dialogs,
  StdCtrls,
  JvPageSetup,
  JvBaseDlg,
  JvWinDialogs;

type
  TfrmPrint_Instrument = class(TForm)
    cbInstruments: TComboBox;
    Label1: TLabel;
    pnlButtons: TPanel;
    btnCancel: TJvXPButton;
    btnPrint: TJvXPButton;
    pnlHeader: TPanel;
    lblHeader: TLabel;
    JvShellAboutDialog1: TJvShellAboutDialog;
    JvPageSetupDialog1: TJvPageSetupDialog;
    PrintDialog1: TPrintDialog;
    procedure FormCreate(Sender: TObject);
    procedure ConfigureForm;
    procedure PopulateComboBox;
    procedure btnCancelClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrint_Instrument         : TfrmPrint_Instrument;

implementation

{$R *.dfm}

uses
 uIA_Const,
  uIA_GUIControl,
  uIA_Utils,
  uPrint_Utils,
  uPrint_PSF;

const
  BlankForms                  : string = 'PTSD Status Form^';


procedure TfrmPrint_Instrument.FormCreate(Sender: TObject);
begin
  Caption := 'Print Assistant';
  lblHeader.Caption := '    Print a blank instrument       version ';
  ConfigureForm;
  PopulateComboBox;
end;

procedure TfrmPrint_Instrument.ConfigureForm;
begin
   // GUI Settings
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      Position := poMainFormCenter;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(guiFont);

      Width := CheckWidth(450, Width);
      Height := CheckHeight(365, Height);

      pnlHeader.Height := pnlHeaderHeight;
      lblHeader.Font.Size := lblHeaderFontSize;
      pnlButtons.Height := 3 * ButtonHeight div 2;

      btnCancel.Left := btnCancel.Width div 3;
      btnCancel.Top := ButtonHeight div 4;
      btnCancel.Height := ButtonHeight;
      btnCancel.Width := ButtonWidthNormal;

      btnPrint.Left := pnlButtons.Width - btnPrint.Width - btnCancel.Left;
      btnPrint.Top := btnCancel.Top;
      btnPrint.Height := ButtonHeight;
      btnPrint.Width := ButtonWidthNormal;
    end;

end;

procedure TfrmPrint_Instrument.PopulateComboBox;
var
  i                           : Integer;
begin
  cbinstruments.Clear;
  for i := 1 to NumberOfPieces(BlankForms, U) do
    cbInstruments.Items.Add(Piece(BlankForms, U, i));
end;

procedure TfrmPrint_Instrument.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPrint_Instrument.btnPrintClick(Sender: TObject);
begin
  if cbInstruments.Text = '' then
    begin
      ShowMessage('No instrument selected');
      Exit;
    end;

  if PrintDialog1.Execute then
    try

      if cbInstruments.Text = 'PTSD Status Form' then
        PrintPSF(sender); // uPrintPSF.pas

    except
      on E: exception do
        begin
          msgDlg(E.message, 'Printing', mterror, [mbok], 0);
          exit;
        end;
    end; {- try -}



end;

end.

