unit fMHA_ASI_Main;

interface

uses
  uMHA_ASI,
  Windows,
  Messages,
  SysUtils,
  System.UITypes,
  DateUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  Contnrs,
  Grids,
  BaseGrid,
  AdvGrid,
  Menus,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  CheckLst,
  ORCtrls,
  RzLabel,
  RzPanel,
  Printers,
  RzButton,
  Dialogs,
  JvExControls,
  JvXPCore,
  JvXPButtons,
  VclTee.TeeGDIPlus,
  AdvObj,
  //patch 123 added to use chm help file
  vcl.HTMLHelpViewer;

type

  TfrmMHA_ASI_Main = class(TForm)
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    PageControl1: TPageControl;
    tsNarrative: TTabSheet;
    tsItemTrends: TTabSheet;
    pnlASITrends: TPanel;
    spltASITrends: TSplitter;
    chrtTrends: TChart;
    Series3: TLineSeries;
    mnuSelectPatient: TMenuItem;
    mnuNewASI: TMenuItem;
    mnuEditASI: TMenuItem;
    mnuView: TMenuItem;
    mnuNarrativeReport: TMenuItem;
    mnuItemReport: TMenuItem;
    mnuItemTrends: TMenuItem;
    mnuDomainScores: TMenuItem;
    tsItemReport: TTabSheet;
    sptItemReport: TSplitter;
    tsDomainScores: TTabSheet;
    pnlItemRepTop: TPanel;
    pnlItemRepBottom: TPanel;
    memASIItemReport: TRichEdit;
    pnlNarrativeRepTop: TPanel;
    sptNarrativeReport: TSplitter;
    pnlNarrativeRepBottom: TPanel;
    memASINarrativeReport: TRichEdit;
    pnlGraphOuter: TPanel;
    spltHorizontal: TSplitter;
    chrtScores: TChart;
    LineSeries1: TLineSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    Series9: TLineSeries;
    Series10: TLineSeries;
    Series6: TLineSeries;
    Series7: TLineSeries;
    Series8: TLineSeries;
    Series11: TLineSeries;
    Series12: TLineSeries;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    N3: TMenuItem;
    SaveDialog1: TSaveDialog;
    ASIPopupMenu1: TPopupMenu;
    mnuPopReport: TMenuItem;
    mnuPopGraph: TMenuItem;
    mnuPopReportPrint: TMenuItem;
    mnuPopReportCopy: TMenuItem;
    mnuPopReportSave: TMenuItem;
    mnuPopGraphPrint: TMenuItem;
    mnuPopGraphCopy: TMenuItem;
    mnuPopGraphSave: TMenuItem;
    mnuNewFull: TMenuItem;
    mnuNewLite: TMenuItem;
    mnuNewFU: TMenuItem;
    mnuAction: TMenuItem;
    mnuProgressNote: TMenuItem;
    N4: TMenuItem;
    mnuTools: TMenuItem;
    mnuOptions: TMenuItem;
    N5: TMenuItem;
    lblPatient: TRzLabel;
    mnuEdit: TMenuItem;
    mnuCopy: TMenuItem;
    N6: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    mnuSaveAs: TMenuItem;
    mnuSaveReport: TMenuItem;
    mnuSaveGraph: TMenuItem;
    mnuPrint: TMenuItem;
    mnuPrintReport: TMenuItem;
    mnuPrintGraph: TMenuItem;
    mnuCopyReport: TMenuItem;
    mnuCopyGraph: TMenuItem;
    mnuPopupNewASI: TPopupMenu;
    mnuFollowUp: TMenuItem;
    mnuLite: TMenuItem;
    mnuFull: TMenuItem;
    pnlTopLeft: TPanel;
    btnNewASI: TRzMenuButton;
    btnEditASI: TButton;
    btnSign: TButton;
    pnlTopLeft1: TPanel;
    btnNewASI1: TRzMenuButton;
    btnEditASI1: TButton;
    btnSignASI1: TButton;
    lblLastASI: TLabel;
    lblLastASI1: TLabel;
    grpASI: TRzGroupBox;
    grdASI1: TAdvStringGrid;
    grpASI1: TRzGroupBox;
    grdASI2: TAdvStringGrid;
    grpTrends: TRzGroupBox;
    grdTrends: TAdvStringGrid;
    grpScores: TRzGroupBox;
    grdScores: TAdvStringGrid;
    mnuPrintTable: TMenuItem;
    mnuSaveTable: TMenuItem;
    mnuCopyTable: TMenuItem;
    mnuPopTable: TMenuItem;
    mnuPopTableCopy: TMenuItem;
    mnuPopTableSave: TMenuItem;
    mnuPopTablePrint: TMenuItem;
    mnuShowGraphLabels: TMenuItem;
    imgBackup: TImage;
    lblPatientScrRdr: TStaticText;
    btnScrRdrExit: TJvXPButton;
    mnuPopNewExit: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ConfigureForm;

    procedure mnuSelectPatientClick(Sender: TObject);
    procedure DisplayTrendsData;
    procedure PageControl1Change(Sender: TObject);
    procedure grdASI1GetCellColor(Sender: TObject; ARow, ACol: Integer;
      AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure grdASI2GetCellColor(Sender: TObject; ARow, ACol: Integer;
      AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure mnuNarrativeReportClick(Sender: TObject);
    procedure mnuItemReportClick(Sender: TObject);
    procedure mnuItemTrendsClick(Sender: TObject);
    procedure mnuDomainScoresClick(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure mnuExitClick(Sender: TObject);
    procedure grdASI1DblClickCell(Sender: TObject; ARow, ACol: Integer);
    procedure pnlNarrativeRepTopResize(Sender: TObject);
    procedure pnlItemRepTopResize(Sender: TObject);
    procedure mnuGraphCopyClick(Sender: TObject);
    procedure mnuGraphPrintClick(Sender: TObject);
    procedure mnuGraphSaveClick(Sender: TObject);
    procedure mnuEditASIClick(Sender: TObject);
    procedure mnuNewFullClick(Sender: TObject);
    procedure mnuNewLiteClick(Sender: TObject);
    procedure mnuNewFUClick(Sender: TObject);
    procedure mnuProgressNoteClick(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure mnuPrintReportClick(Sender: TObject);
    procedure mnuPrintTableClick(Sender: TObject);
    procedure mnuSaveTableClick(Sender: TObject);
    procedure mnuSaveReportClick(Sender: TObject);
    procedure mnuCopyReportClick(Sender: TObject);
    procedure mnuCopyTableClick(Sender: TObject);
    procedure mnuShowGraphLabelsClick(Sender: TObject);
    procedure imgBackupClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UpdateAllDisplays;
    procedure grdScoresRowChanging(Sender: TObject; OldRow,
      NewRow: Integer; var Allow: Boolean);
    procedure grdTrendsRowChanging(Sender: TObject; OldRow,
      NewRow: Integer; var Allow: Boolean);
    procedure grdASI1RowChanging(Sender: TObject; OldRow, NewRow: Integer;
      var Allow: Boolean);
    procedure FormResize(Sender: TObject);
    procedure grdASI2RowChanging(Sender: TObject; OldRow, NewRow: Integer;
      var Allow: Boolean);
    procedure btnNewASIEnter(Sender: TObject);
    procedure mnuPopNewExitClick(Sender: TObject);
    procedure btnScrRdrExitClick(Sender: TObject);
  private
    { Private declarations }

    procedure InitPreviousInterviewsGrids;
    procedure UpdateInterviewGrids(NewRow: Integer);
    procedure UpdateTrends(NewRow: Integer);
    procedure ResetMenuAndButtons;
    procedure InitGrdTrends;
    procedure ListPreviousInterviews;
    procedure ClearPreviousInterviewGrids;
    procedure ClearAMemo(const AReportType: TReportType);
    procedure DisplayReport(const AReportType: TReportType;
      aIENS: string);

    procedure InitGrdDomainScores;
    procedure GraphScores(NewRow: Integer);
    procedure Load_frm_ASI_Entry;
    procedure AdministerNewASI(AInterviewType: TInterviewType);
    function EnterDataForDeadPatient(ACaption: string): BOOLEAN;
    procedure CheckForCrashFile;
    function SignASIMV: Boolean;

  public
    { Public declarations }
  end;

var
  frmMHA_ASI_Main             : TfrmMHA_ASI_Main;

implementation

uses
  uIA_Const,
  uMHA_Const,
  uMHA_Registry,
  uMHA_ASI_OPS,
  uIA_Utils,
  fIA_dialogs,
  uIA_Patient,
  uIA_ThisUser,
  uIA_Patient_OPS,
  uMHA_AResult,
  uIA_GUIControl,
  uMHA_LocalFiles,
  uMHA_Proctor,
  uMHA_ASI_Build,
  fMHA_ASI_Entry,
  fMHA_ASI_Sign,
  uMHA_ASI_Build_508,
  fMHA_ASI_Entry_508,
  fMHA_Options,
  fMHA_Options_508,
  fMHA_About,
  fMHA_Print,
  fMHA_Main;

{$R *.DFM}

const
  COLOR_ITEMREPORT            = $F0FBFF;
  clIndent                    = '   ';
  clSkyBlue                   = TColor($F0CAA6);
  clCream                     = TColor($F0FBFF);
  clWorkspace                 = TColor($F0FBDA);
  clMedGray                   = TColor($A4A0A0);
  clMoneyGreen                = TColor($C0DCC0);

var
  lvOldPageIndex,
    lvDateColWidth,
    lvTypeColWidth            : Integer;

  lvInitialize,
    lvIsFirstViewOfTrendsTab,
    lvIsFirstViewOfDomainScoresTab: BOOLEAN;
  lvScaleGroupList            : TStringList;

procedure TfrmMHA_ASI_Main.FormCreate(Sender: TObject);
begin
  lvInitialize := True;
  Position := poDesigned;
  lvScaleGroupList := TStringList.Create;
  gvCurrentResult := 0;
  Proctor.DataEntryMode := emPatient; // ensures form is not closed when CPRS times out.

  ConfigureForm;
end;

procedure TfrmMHA_ASI_Main.FormShow(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;

  mnuCopyGraph.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuSaveGraph.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPrintGraph.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuPopGraphCopy.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopGraphPrint.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopGraphSave.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuPopTablePrint.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopTableCopy.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopTableSave.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuCopyTable.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuSaveTable.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPrintTable.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuSaveReport.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuPrintReport.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuCopyReport.Enabled := (PageControl1.ActivePageIndex < 2);

  mnuPopReportCopy.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuPopReportPrint.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuPopReportSave.Enabled := (PageControl1.ActivePageIndex < 2);

  CheckForCrashFile;
  UpdateAllDisplays;

  frmMHA_Main.Hide;
  lvInitialize := False;
  Screen.cursor := crDefault;

  // patch 108 508 changes llh -- added begin/end block; changed ActiveControl if screen reader
  if gvUseScreenReader then
  begin
    lblPatient.Visible := false;
    lblHeader.Visible := false ;
    lblPatientScrRdr.Caption := lblHeader.Caption + #13 + lblPatient.Caption ;
    lblPatientScrRdr.Visible := true;
    btnScrRdrExit.Visible := true ;
    mnuPopNewExit.Visible := true;
    grpASI.TabOrder := 0;
    //ActiveControl := grpASI
    ActiveControl := lblPatientScrRdr;
  end
  else
  begin
    //pnlHeader.TabStop := false ;
    imgbackup.Visible := true;
    lblPatientScrRdr.TabStop := false ;
    mnuPopNewExit.Visible := false;
    lblPatient.Visible := true;
    lblHeader.Visible := true ;
    btnScrRdrExit.Visible := false ;
    lblPatientScrRdr.Visible := false;
    ActiveControl := grdASI1;
  end;
end;

procedure TfrmMHA_ASI_Main.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  lvScaleGroupList.Free;

  gvASIWidth := Width;
  gvASIHeight := Height;
  MHA_Registry.SaveRegistry;

  frmMHA_Main.Visible := True;
end;

procedure TfrmMHA_ASI_Main.ConfigureForm;
begin
  MHA_Registry.ReadRegistry;
  Caption := MHA_Caption + ' in use by ' + ThisUser.Name;

  memASIItemReport.Color := COLOR_ITEMREPORT;
  memASINarrativeReport.Color := clInfoBk;

  // Form is designed for font.size = 8; all other sizes are enlarged from that
  // yardstick.
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := GetHeight(gvASIHeight);
      Width := GetWidth(gvASIWidth);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      // 80 for Font.size 8
      lvDateColWidth := TextWidth('XXX/XX/XXXXXXX', gvFont);
      // 70 for Font.size 8
      lvTypeColWidth := TextWidth('XXXXXXXXXX', gvFont);

      if gvFont.Size > 10 then
        memASINarrativeReport.Scrollbars := ssBoth
      else
        memASINarrativeReport.Scrollbars := ssVertical;

      pnlHeader.Height := pnlHeaderHeight;
      lblPatient.Caption := Patient.CaptionInfo;
      lblPatient.Font.Assign(gvFont);
      lblHeader.Font.Assign(gvFont);
      lblHeader.Font.Size := lblHeaderFontSize;
      lblPatient.Font.Size := lblPatientFontSize;

      btnNewASI.Font.Assign(gvFont);
      btnNewASI.Height := ButtonHeight;
      btnNewASI.Width := ButtonWidthNormal;
      btnNewASI.Hint := 'New ASI';

      btnEditASI.Font.Assign(gvFont);
      btnEditASI.Height := ButtonHeight;
      btnEditASI.Width := ButtonWidthNormal;
      btnEditASI.Top := (2 * btnNewASI.Top) + btnNewASI.Height;
      btnEditASI.Hint := 'Edit highlighted ASI';

      btnSign.Font.Assign(gvFont);
      btnSign.Height := ButtonHeight;
      btnSign.Width := ButtonWidthNormal;
      btnSign.Top := (3 * btnNewASI.Top) + (2 * btnNewASI.Height);
      btnSign.Hint := 'Sign highlighted ASI';

      btnNewASI1.Font.Assign(gvFont);
      btnNewASI1.Height := ButtonHeight;
      btnNewASI1.Width := ButtonWidthNormal;
      btnNewASI1.Hint := 'New ASI';

      btnEditASI1.Font.Assign(gvFont);
      btnEditASI1.Height := ButtonHeight;
      btnEditASI1.Width := ButtonWidthNormal;
      btnEditASI1.Top := (2 * btnNewASI.Top) + btnNewASI.Height;
      btnEditASI1.Hint := 'Edit highlighted ASI';

      btnSignASI1.Font.Assign(gvFont);
      btnSignASI1.Height := ButtonHeight;
      btnSignASI1.Width := ButtonWidthNormal;
      btnSignASI1.Top := (3 * btnNewASI.Top) + (2 * btnNewASI.Height);
      btnSignASI1.Hint := 'Sign highlighted ASI';

      pnlTopLeft.Width := (2 * btnNewASI.Left) + btnNewASI.Width;
      pnlTopLeft1.Width := pnlTopLeft.Width;
    end;

  if gvUseScreenReader then
    begin
      Left := 0;
      Width := Screen.Width;
      imgBackup.Visible := False;
      Caption := 'A S I manager for patient ' + Patient.Name;
      // active control is set in form activate

      grpASI.Caption :=
        'Select A S I report. The following grid has five columns: the date of A S I administration,' +
        ' type of A S I, ordered by, whether completed, and if signed. Navigate with' +
        ' the arrow keys, select with return key. Use the tab key to enter grid.';

      grpASI1.Caption :=
        'Select A S I item report. The following grid has five columns: the date of A S I administration,' +
        ' type of A S I, ordered by, whether completed, and if signed. Navigate with' +
        ' the arrow keys, select with return key. Use the tab key to enter grid.';

      grpTrends.Caption :=
        'The following grid summarizes answers on 16 questions from the' +
        ' A S I.  Each row states the question, then responses on various administrations.' +
        ' Navigate with the arrow keys. Enter grid by pressing tab key.';

      grpScores.caption :=
        'The following grid is the A S I domain scores. Navigate with' +
        ' the arrow keys. Press tab key to enter grid.';

      // Don't show chart
      grpTrends.Width := pnlASITrends.Width;
      spltASITrends.Visible := False;
      chrtScores.Visible := False;
      spltHorizontal.Visible := False;
      grpASI.TabStop := True;
      grpASI1.TabStop := True;
      grpTrends.TabStop := True;
      grpScores.TabStop := True;
    end
  else
    begin
      grpASI.TabStop := False;
      grpASI1.TabStop := False;
      grpTrends.TabStop := False;
      grpScores.TabStop := False;
    end;
end;

procedure TfrmMHA_ASI_Main.CheckForCrashFile;
begin
  // Crash recovery file exists only when a non-standard exit occurs from the program.
  // While not showing the form, populate the items with data from ASI_Recovery.txt
  // then store on the dark-side.

  if FileExists(LocalFiles.ASI_RecoveryFile) then
    begin
      if gvUseScreenReader then
        begin
          frmMHA_ASI_Entry_508 := TfrmMHA_ASI_Entry_508.Create(nil);
          ASI_Build_508.SetupComboBoxItems; // uMHA_ASI_Build_508
          ASI_Build_508.DefaultValuesForItems; // uMHA_ASI_Build_508
          frmMHA_ASI_Entry_508.RecoverCrashData;
          frmMHA_ASI_Entry_508.Free;
        end
      else
        begin
          frmMHA_ASI_Entry := TfrmMHA_ASI_Entry.Create(nil);
          ASI_SetupComboBoxItems; // uMHA_ASI_Build
          ASI_DefaultValuesForItems; // uMHA_ASI_Build
          frmMHA_ASI_Entry.RecoverCrashData;
          frmMHA_ASI_Entry.Free;
        end;
    end;
end;

procedure TfrmMHA_ASI_Main.InitPreviousInterviewsGrids;

  procedure InitAGrid(Grid: TAdvStringGrid);
  begin

    with Grid do
      begin
        Font.Assign(gvFont);

        DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy',
          gvFont)) div 2;

        if gvUseScreenReader then
          begin
            SelectionRectangle := True;
            ShowSelection := True;
            Options := [goHorzLine, goDrawFocusSelected, goColSizing,
              goRowSelect];
            FixedRowAlways := False;
            FixedColAlways := False;
            FixedRows := 0;
            FixedCols := 0;
          end
        else
          begin
            SelectionRectangle := False;
            ShowSelection := True;
            Options := [goFixedVertLine, goFixedHorzLine, goVertLine,
              goHorzLine, goDrawFocusSelected, goColSizing, goRowSelect];
            FixedFont.Assign(gvFont);
            FixedRowAlways := True;
            FixedColAlways := false;
            FixedRows := 1;
            FixedCols := 0;
            FixedRowHeight := DefaultRowHeight;
            FixedColWidth := lvDateColWidth;
          end;

        ColCount := 7;

        ColWidths[0] := lvDateColWidth; // Date
        ColWidths[1] := lvTypeColWidth; // Type

        ColWidths[3] := 2 * lvTypeColWidth; // Status (G-12);
        ColWidths[4] := lvTypeColWidth; // Signed
        ColWidths[5] := 0; //ASI.IENS; don't display
        ColWidths[6] := 0; //ASI.CanBeSignedByUser; don't display

        // The width of Col[2] will vary depending on the width of the panel.
        ColumnSize.StretchColumn := 2;
        ColumnSize.Stretch := True;

        Cells[0, 0] := 'Date';
        Cells[1, 0] := 'Type';
        Cells[2, 0] := 'Ordered By';
        Cells[3, 0] := 'Status';
        Cells[4, 0] := 'Signed';
      end;
  end;

begin

  InitAGrid(grdASI1);
  InitAGrid(grdASI2);
  ClearPreviousInterviewGrids;

end;

procedure TfrmMHA_ASI_Main.ResetMenuAndButtons;
var
  AllowSign,
    AllowEdit                 : Boolean;
begin
  if ASI_OPS.ListOfASIResults.Count = 0 then
    Exit;

  mnuFollowup.Enabled := ASI_OPS.SignedInterviewsExist;

  AllowEdit := not TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).Issigned;
  if grdASI1.Cells[1, grdASI1.Row] = ASI_MV then
    AllowEdit := False;

  mnuEditASI.Enabled := AllowEdit;
  btnEditASI.Enabled := AllowEdit;
  btnEditASI1.Enabled := AllowEdit;

  AllowSign := (not TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).Issigned) and
    (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).CanBeSignedByUser);

  btnSign.Visible := AllowSign;
  btnSignASI1.Visible := AllowSign;

  //The and condition was dropped to allow clerk entry by someone
  //other than the ordered by who is to sign the ASI
  //and ASI.CanBeSignedByUser;

  mnuNewFU.Enabled := ASI_OPS.SignedInterviewsExist;
  mnuDomainScores.Enabled := ASI_OPS.SignedInterviewsExist;
  mnuItemTrends.Enabled := ASI_OPS.SignedInterviewsExist;

  mnuProgressNote.Enabled := ASI_OPS.SignedInterviewsExist
    and TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IsSigned
    and TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).CanBeSignedByUser;

end;

procedure TfrmMHA_ASI_Main.InitGrdDomainScores;
var
  j, aCol, r                  : Integer;
  TempStr                     : string;
begin
  // This maybe change later, provides cleaner look when starting up.
  chrtScores.Legend.Visible := False;

  with grdScores do
    begin
      Font.Assign(gvFont);
      ColCount := ASI_OPS.ListOfASIResults.Count + 1;
      RowCount := 14;

      if gvUseScreenReader then
        begin
          SelectionRectangle := True;
          ShowSelection := True;
          Options := [goHorzLine, goDrawFocusSelected, goColSizing,
            goRowSelect];
          FixedRowAlways := False;
          FixedColAlways := False;
          FixedRows := 0;
          FixedCols := 0;
        end
      else
        begin
          SelectionRectangle := False;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          FixedFont.Assign(gvFont);
          FixedRowAlways := True;
          FixedColAlways := false;
          FixedRows := 1;
          FixedCols := 0;
          FixedRowHeight := DefaultRowHeight;
          FixedColWidth := GUI_Control.TextWidth('Evaluation Factors',
            gvFont) + 30; //2 * lvDateColWidth;
        end;

      DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy', gvFont))
        div 2;

      ColumnSize.Stretch := true;

      DefaultColWidth := lvDateColWidth; //80
      ColWidths[0] := GUI_Control.TextWidth('Evaluation Factors',
        gvFont) + 30;

      cells[0, 1] := 'Evaluation Factors';
      FontStyles[0, 1] := [fsBold];

      cells[0, 2] := '   Alcohol (EF)';
      cells[0, 3] := '   Drug (EF)';
      cells[0, 4] := '   Legal (EF)';
      cells[0, 5] := '   Psychiatric (EF)';
      cells[0, 6] := '   Family/Social (EF)';

      cells[0, 7] := 'Severity Ratings';
      FontStyles[0, 7] := [fsBold];

      cells[0, 8] := '   Medical (SR)';
      cells[0, 9] := '   Employment (SR)';
      cells[0, 10] := '   Alcohol (SR)';
      cells[0, 11] := '   Drug (SR)';
      cells[0, 12] := '   Legal (SR)';
      cells[0, 13] := '   Family/Social (SR)';
      cells[0, 14] := '   Psychiatric (SR)';

      aCol := 1;

      for r := 1 to grdASI1.RowCount do
        begin
          if (grdASI1.Cells[4, r] = 'True') and
            (grdASI1.Cells[3, r] = 'Completed') then
            begin
              grdScores.Cells[aCol, 0] := grdASI1.Cells[0, r];
              grdScores.FontStyles[aCol, 0] := [fsBold];
              grdScores.ColWidths[aCol] := lvDateColwidth;

              TempStr :=
                ASI_OPS.LoadEvaluationFactors(grdASI1.Cells[5, r]); // IENS
              for j := 1 to 5 do
                grdScores.Cells[aCol, j + 1] :=
                  Piece(TempStr, U, j);

              TempStr :=
                ASI_OPS.LoadSeverityRatings(grdASI1.Cells[5, r]);
              for j := 1 to 7 do
                grdScores.Cells[aCol, j + 7] :=
                  Piece(TempStr, U, j);

              Inc(aCol);
            end; // IsSigned
        end; // for i

      grdScores.ColCount := aCol;

      if gvUseScreenReader then
        Cells[0, 0] := 'Dates';

    end; //with grdScores
end;


procedure TfrmMHA_ASI_Main.InitGrdTrends;
begin
  //load item number and Text

  with grdTrends do
    begin
      ColCount := ASI_OPS.ListOfASIResults.Count + 1;
      Font.Assign(gvFont);

      if gvUseScreenReader then
        begin
          SelectionRectangle := True;
          ShowSelection := True;
          Options := [goHorzLine, goDrawFocusSelected, goColSizing,
            goRowSelect];
          FixedRowAlways := False;
          FixedColAlways := False;
          FixedRows := 0;
          FixedCols := 0;
        end
      else
        begin
          SelectionRectangle := False;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          FixedFont.Assign(gvFont);
          FixedRowAlways := True;
          FixedColAlways := false;
          FixedRows := 1;
          FixedCols := 0;
          FixedRowHeight := DefaultRowHeight;
        end;

      DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy', gvFont))
        div 2;

      // Set col width to longest label
      ColWidths[0] := GUI_Control.TextWidth('XP11 Days psych/emot. problemsX',
        gvFont);
      Cells[0, 0] := 'Item';
      Cells[0, 1] := 'M6 Days medical problems';
      Cells[0, 2] := 'E11 Days worked';
      Cells[0, 3] := 'E12 Money earned';
      Cells[0, 4] := 'E17 Illegal income';
      Cells[0, 5] := 'D1 Days used alcohol';
      Cells[0, 6] := 'D2 Days alcohol intoxication';
      Cells[0, 7] := 'D3 Days used heroin';
      Cells[0, 8] := 'D5 Days used other opiates';
      Cells[0, 9] := 'D7 Days used sed/hypn/tranq';
      Cells[0, 10] := 'D8 Days used cocaine';
      Cells[0, 11] := 'D23 Money spent on alcohol';
      Cells[0, 12] := 'D24 Money spent on drugs';
      Cells[0, 13] := 'L27 Days illegal activities';
      Cells[0, 14] := 'F30 Days of family conflict';
      Cells[0, 15] := 'F31 Days of other conflict';
      Cells[0, 16] := 'P11 Days psych/emot. problems';

      if gvUseScreenReader then
        Cells[0, 0] := 'Dates';
    end;
end;

procedure TfrmMHA_ASI_Main.mnuSelectPatientClick(Sender: TObject);
var
  Save_Cursor                 : TCursor;
  OldDFN                      : string;
begin
  OldDFN := Patient.DFN;

  if (DataBaseMode = dbVista) then
    begin
      Save_Cursor := Screen.Cursor;
      Screen.Cursor := crHourglass; { Show hourglass cursor }
      try
        Patient_OPS.SelectUsingCPRS;
      finally
        Screen.Cursor := Save_Cursor; { Always restore to normal }
      end; //try
    end; //dbVista

  if not (OldDFN = Patient.DFN) then
    begin
      UpdateAllDisplays;
      ActiveControl := grdASI1;
    end;
end;

procedure TfrmMHA_ASI_Main.ClearPreviousInterviewGrids;

  procedure ClearAGrid(Grid: TAdvStringGrid);
  var
    r, c                      : integer;
  begin
    with Grid do
      begin
        for r := 1 to RowCount do
          for c := 0 to ColCount do
            Cells[c, r] := '';
        //Cells[0, 1] := 'Loading...';
      end; //with Grid
  end;

begin
  ClearAGrid(grdASI1);
  ClearAGrid(grdASI2);
end;

procedure TfrmMHA_ASI_Main.ClearAMemo(const AReportType: TReportType);
begin

  case AReportType of
    rtNarrative:
      with memASINarrativeReport do
        begin
          Clear;
          Lines.Add('Loading report...');
        end;
    rtItem:
      with memASIItemReport do
        begin
          Clear;
          Lines.Add('Loading report...');
        end;
  end;

end;

procedure TfrmMHA_ASI_Main.UpdateAllDisplays;
begin
  lblPatient.Caption := Patient.CaptionInfo;
  lblPatient.Update;

  // This clears the previous patient's list of interviews and report before
  // loading of new data begins so the user no longer sees old data
  ClearPreviousInterviewGrids;
  ClearAMemo(rtNarrative);
  ClearAMemo(rtItem);

  InitPreviousInterviewsGrids;

  // This method builds a list of all previous interviews, signed or not
  ListPreviousInterviews;
  InitGrdTrends;

  PageControl1.ActivePageIndex := 0;
  lvIsFirstViewOfTrendsTab := True;
  lvIsFirstViewOfDomainScoresTab := True;

  if (grdASI1.Cells[0, 1] = '') or
    (grdASI1.Cells[0, 1] = 'None') or
    Patient.IsDead then
    begin
      lblLastASI.visible := false;
      lblLastASI1.visible := false;
      mnuEdit.Enabled := false;
      mnuPrint.Enabled := false;
      mnuSaveAs.Enabled := false;
      btnSign.Enabled := False;
      btnSignASI1.Enabled := False;
      btnEditASI.Enabled := False;
      btnEditASI1.Enabled := False;
      memASINarrativeReport.Clear;
    end
  else
    begin
      mnuEdit.Enabled := true;
      mnuPrint.Enabled := true;
      mnuSaveAs.Enabled := true;
      btnSign.Enabled := True;
      btnSignASI1.Enabled := True;
      btnEditASI.Enabled := True;
      btnEditASI1.Enabled := True;

      lblLastASI.Caption := ({'Last ASI ' + }
        IntToStr(DaysBetween(StrToDate(grdASI1.Cells[0, 1]), Now)) +
        ' days since last ASI');

      lblLastASI1.Caption := lblLastASI.Caption;
      lblLastASI.visible := true;
      lblLastASI1.visible := true;
    end;

  UpdateInterviewGrids(1);
end;

procedure TfrmMHA_ASI_Main.ListPreviousInterviews;
var
  pnlHeight                   : integer;

  procedure WriteDataToGrid(AGrid: TAdvStringGrid);
  var
    i                         : integer;
  begin
    with AGrid do
      begin

        //If no previous ASI's
        if ASI_OPS.ListOfASIResults.Count = 0 then
          Cells[0, 1] := 'None'
        else
          // If there are previous ASI's
          begin
            RowCount := ASI_OPS.ListOfASIResults.Count + 1;

            for i := 0 to ASI_OPS.ListOfASIResults.Count - 1 do
              begin
                Cells[0, i + 1] := DateToStr(TASI(ASI_OPS.ListOfASIResults[i]).ASIDate);
                Cells[1, i + 1] := TASI(ASI_OPS.ListOfASIResults[i]).InterviewTypeStr;
                Cells[2, i + 1] := TASI(ASI_OPS.ListOfASIResults[i]).OrderedByName;
                Cells[3, i + 1] := TASI(ASI_OPS.ListOfASIResults[i]).G12; // Status
                Cells[4, i + 1] := MixedCase(BoolToStr(TASI(ASI_OPS.ListOfASIResults[i]).IsSigned));
                Cells[5, i + 1] := TASI(ASI_OPS.ListOfASIResults[i]).IENS;
                Cells[6, i + 1] := BoolToStr(TASI(ASI_OPS.ListOfASIResults[i]).CanBeSignedByUser);
              end; // for i...
          end; //else

        SortSettings.Direction := sdDescending;
        SortByColumn(0);

        pnlHeight := ((RowCount + 1) * RowHeights[1]) - 10;
      end; //with

    // The grid and the ListOfASIResults may not be in the same order
    gvCurrentResult := ASI_OPS.Synch(grdASI1.cells[5, 1]);
  end;

begin

  ASI_OPS.ListOfASIResults.Clear;

  // Populate the ASI_OPS.ListOfASIResults--uMHA_ASI_IO
  if not ASI_OPS.LoadPreviousASIs(Patient.DFN) then
    begin
      ShowMessage('Error in loading the previous ASI results');
      Exit;
    end;

  WriteDataToGrid(grdASI1);
  WriteDataToGrid(grdASI2);

  pnlNarrativeRepTop.Height := GUI_Control.ButtonHeight * 6; //pnlHeight;
  pnlItemRepTop.Height := GUI_Control.ButtonHeight * 6; //pnlHeight;

(*  if (pnlHeight < 200) then
    begin
      pnlNarrativeRepTop.Height := GUI_Control.ButtonHeight * 5; //pnlHeight;
      pnlItemRepTop.Height := GUI_Control.ButtonHeight * 5; //pnlHeight;
    end
  else
    begin
      pnlNarrativeRepTop.Height := 200;
      pnlItemRepTop.Height := 200;
    end;*)

end;

procedure TfrmMHA_ASI_Main.DisplayReport(const AReportType: TReportType;
  aIENS: string);
begin
  //This makes the pagecontrol change look crisper
  Application.ProcessMessages;

  case aReportType of
    rtNarrative:
      with memASINarrativeReport do
        begin
          //Exit if no ASI
          if ASI_OPS.ListOfASIResults.Count = 0 then
            begin
              Clear;
              Lines.Add('No previous interviews.');
              Exit;
            end; //if not...

          Font.Name := 'Courier New';
          Font.Size := gvFont.Size;
          //? XE3 migration llh, if gvFont.size = 0 above,
          //?                            force to a size
          if gvFont.Size = 0 then Font.Size := 8 ;
          Font.Color := gvFont.color;
          Font.Style := gvFont.style;

          Text := ASI_OPS.LoadReport(aIENS, rtNarrative);
          MaxLength := Length(Text);

        end; //with...

    rtItem:
      with memASIItemReport do
        begin
          //Exit if no ASI
          if ASI_OPS.ListOfASIResults.Count = 0 then
            begin
              Clear;
              Lines.Add('No previous interviews.');
              Exit;
            end; //if not...

          Font.Name := 'Courier New';
          //? XE3 migration llh, if gvFont.size = 0 here, force to default
          //Font.Size := gvFont.Size;
          if gvFont.Size = 0 then Font.Size := 8 ;
          Font.Color := gvFont.color;
          Font.Style := gvFont.style;

          Text := ASI_OPS.LoadReport(aIENS, rtItem);
          MaxLength := Length(Text);
        end; //with...

  end; //case...

end;


procedure TfrmMHA_ASI_Main.DisplayTrendsData;
var
  i, aCol,
    aRow                      : integer;
  tmpRead                     : string;
  //tmpWrite, BlankLine: string;
begin
  aCol := 0;
  //BlankLine := '                  ';

  for i := 1 to grdASI1.RowCount - 1 do
    begin

      if grdASI1.Cells[4, i] = 'True' then
        begin
          ASI_OPS.LoadTrends(grdASI1.Cells[5, i]); // IENS
          Inc(aCol);
          grdTrends.ColWidths[aCol] := lvDateColWidth;
          grdTrends.Cells[aCol, 0] := grdASI1.Cells[0, i];
          // Write the item values for the interview
          for aRow := 1 to 16 do
            begin
              tmpRead := Piece(ASI_OPS.ItemValues[aRow - 1], EQ, 2);
              //Insert(tmpRead, tmpWrite, 10 - Length(tmpRead));
              grdTrends.Cells[aCol, aRow] := tmpRead; //TrimRight(tmpWrite);
            end; //for aRow := 1 to 16

        end; // if true
    end; // for i

  grdTrends.ColCount := aCol + 1;
  UpdateTrends(1);

end;

procedure TfrmMHA_ASI_Main.PageControl1Change(Sender: TObject);

  procedure DoNotChange(AMsg: string);
  begin
    PageControl1.ActivePageIndex := lvOldPageIndex;
    Application.ProcessMessages;
    MsgDlgFrm(AMsg + 'cannot be shown because there are no signed ASI' + #39
      + 's.', MHA_Caption, mtInformation, [mbOK], 0);
  end;

begin

  case PageControl1.ActivePageIndex of
    0:
      begin
        //pnlNarrativeRepTop.Height := pnlItemRepTop.Height; // Narrative Report
        if gvUseScreenReader then
          ActiveControl := grpASI;
      end;
    1:
      begin
        //pnlItemRepTop.Height := pnlNarrativeRepTop.Height; // Item Report
        if gvUseScreenReader then
          ActiveControl := grpASI1;
      end;

    2: // Item Trends
      begin
        if not ASI_OPS.SignedInterviewsExist then
          begin
            DoNotChange('Item trends ');
            Exit;
          end; //signed interviews do not exist

        if lvIsFirstViewOfTrendsTab then
          DisplayTrendsData;

        lvIsFirstViewOfTrendsTab := False;

        if gvUseScreenReader then
          ActiveControl := grpTrends;

      end; // Item Trends

    3: // Domain Scores
      begin
        if not ASI_OPS.SignedInterviewsExist then
          begin
            DoNotChange('Domain scores ');
            Exit;
          end; //signed interviews do not exist

        if lvIsFirstViewOfDomainScoresTab then
          begin
            InitGrdDomainScores;
            GraphScores(1);
          end;

        lvIsFirstViewOfDomainScoresTab := False;

        if gvUseScreenReader then
          ActiveControl := grpScores;

      end; // Domain Scores

  end; //case ActivePageIndex

  mnuCopyGraph.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuSaveGraph.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPrintGraph.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuPopGraphCopy.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopGraphPrint.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopGraphSave.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuPopTablePrint.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopTableCopy.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPopTableSave.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuCopyTable.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuSaveTable.Enabled := (PageControl1.ActivePageIndex > 1);
  mnuPrintTable.Enabled := (PageControl1.ActivePageIndex > 1);

  mnuSaveReport.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuPrintReport.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuCopyReport.Enabled := (PageControl1.ActivePageIndex < 2);

  mnuPopReportCopy.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuPopReportPrint.Enabled := (PageControl1.ActivePageIndex < 2);
  mnuPopReportSave.Enabled := (PageControl1.ActivePageIndex < 2);

  mnuEditASI.Enabled := (PageControl1.ActivePageIndex < 2);
end;


procedure TfrmMHA_ASI_Main.UpdateTrends(NewRow: Integer);
var
  icol,
    CellValue                 : integer;
begin
  with chrtTrends do
    begin
      Title.Text.Clear;
      Title.Text.Text := 'ASI ' + grdTrends.Cells[0, NewRow];
      Series3.Clear;

      for icol := 1 to grdTrends.ColCount - 1 do
        begin
          CellValue := StrToIntDef(Trim(grdTrends.Cells[icol, NewRow]), -1);

          //Skip non-integers
          if not (CellValue = -1) then
            Series3.AddXy(StrToDate(grdTrends.Cells[icol, 0]),
              CellValue, grdTrends.Cells[icol, 0], clRed);

        end; //for icol

    end; //with chrtTrends
end;

procedure TfrmMHA_ASI_Main.grdASI1GetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
  if (UpperCase(grdASI1.Cells[4, ARow]) = 'FALSE')
    and (UpperCase(grdASI1.Cells[6, ARow]) = 'TRUE') then
    AFont.Style := [fsBold];
end;


procedure TfrmMHA_ASI_Main.grdASI2GetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
  if (UpperCase(grdASI1.Cells[4, ARow]) = 'FALSE')
    and (UpperCase(grdASI1.Cells[6, ARow]) = 'TRUE') then
    AFont.Style := [fsBold];
end;

procedure TfrmMHA_ASI_Main.mnuNarrativeReportClick(Sender: TObject);
begin
  // NB: Contrary to expectation, resetting the ActivePageIndex changes
  // the tab that is seen but does not invoke the PageControlChange event,
  // so it has to be called separately.  Go figure!
  PageControl1.ActivePageIndex := 0;
  PageControl1Change(Self);
end;

procedure TfrmMHA_ASI_Main.mnuItemReportClick(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 1;
  PageControl1Change(Self);
end;

procedure TfrmMHA_ASI_Main.mnuItemTrendsClick(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 2;
  PageControl1Change(Self);
end;

procedure TfrmMHA_ASI_Main.mnuDomainScoresClick(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 3;
  PageControl1Change(Self);
end;

procedure TfrmMHA_ASI_Main.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  lvOldPageIndex := PageControl1.ActivePageIndex;

end;

procedure TfrmMHA_ASI_Main.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_ASI_Main.mnuAboutClick(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA_ASI_Main.mnuOnlineSupportClick(Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;

procedure TfrmMHA_ASI_Main.GraphScores(NewRow: Integer);
var
  iseries                     : Integer;
  MyColor                     : TColor;
  xlabel, CellValue           : string;

  procedure GraphSeveralScales(StartRow, EndRow: Integer);
  var
    i, icol, irow, ordinate   : Integer;
  begin
    i := -1;

    for iCol := 1 to grdScores.ColCount - 1 do
      begin
        inc(i);

        if i > 9 then
          Exit;

        chrtScores.Series[i].Active := True;
        MyColor := chrtScores.Series[i].SeriesColor;
        chrtScores.Series[i].Title := grdScores.Cells[iCol, 0]; // Date

        for irow := StartRow to EndRow do
          begin

            CellValue := Trim(grdScores.Cells[iCol, iRow]);

              //be sure the cell contains an integer
            if (StrToIntDef(CellValue, -1) > -1) then
              begin
                ordinate := StrToInt(CellValue);

                //The abcissa labels need to be written only once (the first time)
                if (i = 0) then
                  begin
                    xlabel := grdScores.Cells[0, iRow];
                  end
                else
                  xlabel := '';

                chrtScores.Series[i].AddXy(iRow, ordinate,
                  xlabel, MyColor);
              end; //if statement

          end; // for iRow
      end; // for iCol
  end;

  procedure GraphThisScale;
  var
    i, icol, ordinate         : Integer;
  begin
    i := 0;
    chrtScores.Series[i].Active := True;
    MyColor := chrtScores.Series[i].SeriesColor;
    chrtScores.Series[i].Title := grdScores.Cells[0, NewRow];

    for iCol := 1 to grdScores.ColCount do
      begin

        CellValue := Trim(grdScores.Cells[icol, NewRow]);
              //be sure the cell contains an integer
        if (StrToIntDef(CellValue, -1) > -1) then
          begin
            ordinate := StrToInt(CellValue);

            xlabel := Trim(grdScores.Cells[icol, 0]);
            xlabel := Piece(xlabel, ' ', 1);

            chrtScores.Series[i].AddXy(icol, ordinate,
              xlabel, MyColor);
          end; //if statement
      end; // for iCol
  end;

begin

  //clear the chart
  with chrtScores do
    begin
      for iseries := 0 to 9 do
        begin
          Series[iseries].Clear;
          Series[iseries].Active := False;
        end;

      Legend.FirstValue := 0;
      Legend.Visible := ((NewRow = 7) or (NewRow = 1));
      Title.Text.Text := 'ASI ' + grdScores.Cells[0, NewRow];

      //set left axis
      with LeftAxis do
        begin
          if NewRow < 7 then
            begin
              Title.Caption := 'T Scores';
              Increment := 1;
              Maximum := 75;
              Minimum := 25;
            end
          else
            begin
              Title.Caption := 'Ratings';
              Increment := 1;
              Minimum := 0;
              Maximum := 9;
            end;
        end; //with left axis

    end; //with chrtTestGraph

  if NewRow = 1 then
    GraphSeveralScales(2, 6);

  if NewRow = 7 then
    GraphSeveralScales(8, 14);

  if ((NewRow > 1) and (NewRow < 7)) or
    (NewRow > 7) then
    GraphThisScale;

end;


procedure TfrmMHA_ASI_Main.UpdateInterviewGrids(NewRow: Integer);
begin

  if (NewRow > 0) then
    begin
      ClearAMemo(rtNarrative);
      ClearAMemo(rtItem);

      // The grid and the ListOfASIResults may not be in the same order
      gvCurrentResult := ASI_OPS.Synch(grdASI1.cells[5, NewRow]);

      //Update currently viewed report first
      case PageControl1.ActivePageIndex of
        0:
          begin
            DisplayReport(rtNarrative, grdASI1.cells[5, NewRow]);
            DisplayReport(rtItem, grdASI1.cells[5, NewRow]);
          end;

        1:
          begin
            DisplayReport(rtItem, grdASI1.cells[5, NewRow]);
            DisplayReport(rtNarrative, grdASI1.cells[5, NewRow]);
          end;

      end; //case

      ResetMenuAndButtons;
    end;
end;

procedure TfrmMHA_ASI_Main.grdASI1DblClickCell(Sender: TObject; ARow,
  ACol: Integer);

  procedure SortPreviousInterviews(AGrid: TAdvStringGrid);
  begin
    if (ACol = 0) then
      AGrid.SortSettings.Direction := sdDescending
    else
      AGrid.SortSettings.Direction := sdAscending;

    AGrid.SortByColumn(ACol);
  end;

begin

  if (ARow > 0) then
    Exit;

  SortPreviousInterviews(grdASI1);
  SortPreviousInterviews(grdASI2);

  UpdateInterviewGrids(1);
end;



procedure TfrmMHA_ASI_Main.pnlNarrativeRepTopResize(Sender: TObject);
var
  tmpWidth                    : Integer;
begin
  with grdASI1 do
    begin
      // The width of Col[2] will vary depending on the width of the panel.
      tmpWidth := pnlNarrativeRepTop.Width -
        (ColWidths[0] + ColWidths[1] + ColWidths[3] + ColWidths[4]);
      if tmpWidth < lvTypeColWidth + lvDateColWidth then
        tmpWidth := lvTypeColWidth + lvDateColWidth;
      ColWidths[2] := tmpWidth;
    end;
end;

procedure TfrmMHA_ASI_Main.pnlItemRepTopResize(Sender: TObject);
var
  tmpWidth                    : Integer;
begin
  with grdASI2 do
    begin
      // The width of Col[3] will vary depending on the width of the panel.
      tmpWidth := pnlNarrativeRepTop.Width -
        (ColWidths[0] + ColWidths[1] + ColWidths[3] + ColWidths[4]);
      if tmpWidth < lvTypeColWidth + lvDateColWidth then
        tmpWidth := lvTypeColWidth + lvDateColWidth;
      ColWidths[2] := tmpWidth;
    end;
end;

procedure TfrmMHA_ASI_Main.mnuGraphCopyClick(Sender: TObject);
var
  tmpMsg                      : string;
begin
  case PageControl1.ActivePageIndex of
    2:
      begin
        chrtTrends.Title.Visible := True;
        chrtTrends.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
        chrtTrends.CopyToClipboardBitmap;
        chrtTrends.Title.Text.Clear;

        tmpMsg := 'The ASI trends graph has been copied to the Windows clipboard.'
          + CRLF + CRLF
          + 'If you like, you may paste it into a text document.'
      end;
    3:
      begin
        chrtScores.Title.Visible := True;
        chrtScores.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
        chrtScores.CopyToClipboardBitmap;
        chrtScores.Title.Text.Clear;

        tmpMsg := 'The ASI domain scores graph has been copied to the Windows clipboard.'
          + CRLF + CRLF
          + 'If you like, you may paste it into a text document.'
      end;
  end;

  MsgDlgFrm(tmpMsg, MHA_Caption, mtInformation, [mbOK], 0);

end;

procedure TfrmMHA_ASI_Main.mnuGraphPrintClick(Sender: TObject);
begin

  if PageControl1.ActivePageIndex = 2 then
    begin
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintChart(chrtTrends, Patient.Name + '  SSN: ' + Patient.FormattedSSN
        + '  Printed: ' + DateToStr(Date));
      frmMHA_Print.Free;
      chrtTrends.Foot.Text.Text := '';
    end;

  if PageControl1.ActivePageIndex = 3 then
    begin
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintChart(chrtScores, Patient.Name + '  SSN: ' + Patient.FormattedSSN
        + '  Printed: ' + DateToStr(Date));
      frmMHA_Print.Free;
      chrtScores.Foot.Text.Text := '';
    end;
end;

procedure TfrmMHA_ASI_Main.mnuGraphSaveClick(Sender: TObject);
begin
  with SaveDialog1 do
    case PageControl1.ActivePageIndex of
      2:
        begin
          FileName := 'ASI Trends.bmp';
          Filter := 'Bitmap files (*.bmp)|*.bmp';
          if Execute then
            begin
              chrtTrends.Title.Text.Clear;
              chrtTrends.Title.Visible := True;
              chrtTrends.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
              chrtTrends.SaveToBitmapFile(FileName);
              chrtTrends.Title.Text.Clear;
            end;
        end;
      3:
        begin
          FileName := 'ASI Domain Scores.bmp';
          Filter := 'Bitmap files (*.bmp)|*.bmp';
          if Execute then
            begin
              chrtTrends.Title.Text.Clear;
              chrtScores.Title.Visible := True;
              chrtScores.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
              chrtScores.SaveToBitmapFile(FileName);
              chrtScores.Title.Text.Clear;
            end;
        end;
    end;
end;

procedure TfrmMHA_ASI_Main.Load_frm_ASI_Entry;
begin
  if gvUseScreenReader then
    begin
      frmMHA_ASI_Entry_508 := TfrmMHA_ASI_Entry_508.Create(nil);
      try
        // ShowModal: call this from the main form, otherwise the SaveData
        // does not work when the form is timed out by Vista.
        frmMHA_ASI_Entry_508.ShowModal;
      finally
        frmMHA_ASI_Entry_508.Free;
      end
    end

  else

    begin
      frmMHA_ASI_Entry := TfrmMHA_ASI_Entry.Create(nil);
      try
        // ShowModal: call this from the main form, otherwise the SaveData
        // does not work when the form is timed out by Vista.
        frmMHA_ASI_Entry.ShowModal;
      finally
        frmMHA_ASI_Entry.Free;
      end
    end;

  UpdateAllDisplays;

end;


function TfrmMHA_ASI_Main.SignASIMV: boolean;
var
  Sig,
    MySig                     : string;
label
  skip;

  function GetElectronicSignature: string;
  begin
    SignatureForASI(gvFont.Size,
      'Sign the Addiction Severity Index - MV',
      'Electronic Signature',
      MySig);

    if MySig = '' then
      begin
        result := 'Cancel';
        exit;
      end;

    if ASI_OPS.Sign(MySig, grdASI1.Cells[5, grdASI1.Row] {IEN}) then
      result := 'Done'
    else
      result := 'Error';
  end;

begin
  result := false;

  // Ensure that "Ordered By" is the person signing this ASI.
  if not ASI.CanBeSignedByUser then
    begin
      MsgDlgFrm('The only person allowed to sign this ASI is "Ordered By".',
        'Electronic Signature', mtInformation, [mbOK], 0);
      exit;
    end;

  // User signs ASI-MV
  repeat
    Sig := GetElectronicSignature;
    if sig = 'Cancel' then
      exit;
    if Sig = 'Done' then
      goto Skip;

    MsgDlgFrm('This signature was not recognized.'
      +
      'Please try again.',
      'Electronic Signature', mtInformation, [mbOK], 0);

  until sig = 'Done';
  skip:

  if (Sig = 'Done') then
    begin
      if
        MsgDlgFrm('Would you like to save a narrative progress note for this ASI-MV?',
        MHA_Caption, mtConfirmation, [mbYes, mbNo], 0)
        = mrYes then

        if not ASI_OPS.SaveProgressNote(grdASI1.Cells[5, grdASI1.Row]) then
          MsgDlgFrm('The ASI progress note was not written to VistA database.',
            MHA_Caption, mtError, [mbOK], 0);

    end;

  result := true;
end;

 procedure TfrmMHA_ASI_Main.mnuEditASIClick(Sender: TObject);
begin
  if not EnterDataForDeadPatient('edit an ASI') then
    Exit;

  case PageControl1.ActivePageIndex of
    // Start with IEN for this ASI administration,
    // go to Synch to get index number
    // for the results in ListOfASIResults -- gvCurrentResults
    0: gvCurrentResult := ASI_OPS.Synch(grdASI1.Cells[5, grdASI1.Row]);
    1: gvCurrentResult := ASI_OPS.Synch(grdASI2.Cells[5, grdASI2.Row]);
  else
    Exit;
  end;

  // ASI-MV can not be edited, only signed.
  if ((PageControl1.ActivePageIndex = 0) and
    (grdASI1.Cells[1, grdASI1.row] = ASI_MV) and
    (grdASI1.Cells[4, grdASI1.row] = 'False') and
    (grdASI1.Cells[6, grdASI1.row] = 'TRUE')) or
    ((PageControl1.ActivePageIndex = 1) and
    (grdASI2.Cells[1, grdASI2.row] = ASI_MV) and
    (grdASI2.Cells[4, grdASI2.row] = 'False') and
    (grdASI2.Cells[6, grdASI2.row] = 'TRUE')) then
    begin
      SignASIMV;
      Exit;
    end;

  Load_frm_ASI_Entry;

end;

procedure TfrmMHA_ASI_Main.mnuNewFullClick(Sender: TObject);
begin
  AdministerNewASI(itFull);
end;

procedure TfrmMHA_ASI_Main.AdministerNewASI(AInterviewType: TInterviewType);
begin
  if not EnterDataForDeadPatient('enter a new ASI') then
    Exit;

  ASI_OPS.LoadNew(AInterviewType); // gvCurrentResult set here

  Load_frm_ASI_Entry;
end;

procedure TfrmMHA_ASI_Main.mnuNewLiteClick(Sender: TObject);
begin
  AdministerNewASI(itLite);
end;

procedure TfrmMHA_ASI_Main.mnuNewFUClick(Sender: TObject);
begin
  AdministerNewASI(itFU);
end;

procedure TfrmMHA_ASI_Main.mnuProgressNoteClick(Sender: TObject);
var
  tmpMsg                      : string;
begin
  if ASI_OPS.SaveProgressNote(TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS) then
    tmpMsg := 'The progress note was saved successfully.' + CRLF + CRLF
      + 'Please go to CPRS to edit and sign the note.'
  else
    tmpMsg := 'The progress note was not saved.' + CRLF + CRLF
      + 'You may try again, but if the problem persists, please contact your IRMS';

  MsgDlgFrm(tmpMsg, MHA_Caption, mtInformation, [mbOK], 0);

end;

procedure TfrmMHA_ASI_Main.mnuOptionsClick(Sender: TObject);
begin
  if gvUseScreenReader then
    begin
      try
        frmMHA_Options_508 := TfrmMHA_Options_508.Create(nil);
      finally
        frmMHA_Options_508.Free;
      end;

    end
  else
    begin
      gvShowOptionTabs := '0'; // Show tab 0 on options form, Fonts
      try
        frmMHA_Options := TfrmMHA_Options.Create(nil);
    //frmMHA_Options.ShowModal;
      finally
        frmMHA_Options.Free;
      end;

      if GUI_Control.NeedGUIUpdate then
        begin
          with GUI_Control do
            begin
      // 80 for Font.size 8
              lvDateColWidth := TextWidth('XXX/XX/XXXXX', gvFont);
      // 70 for Font.size 8
              lvTypeColWidth := TextWidth('XXXXXXXXXX', gvFont);
              if gvFont.Size > 10 then
                memASINarrativeReport.Scrollbars := ssBoth
              else
                memASINarrativeReport.Scrollbars := ssVertical;
            end;

          InitPreviousInterviewsGrids;
          UpdateAllDisplays;
          pagecontrol1.Font.Assign(gvFont);
        end;
    end;
end;

procedure TfrmMHA_ASI_Main.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;
end;


function TfrmMHA_ASI_Main.EnterDataForDeadPatient(ACaption: string): BOOLEAN;
var
  tmpCaption                  : string;
begin

  Result := True;
  if Patient.IsDead then
    begin
      tmpCaption := ACaption;
      Result := (MsgDlgFrm(Patient.Name + ' died on ' + Patient.DOD +
        '.  Are you sure '
        + 'you want to ' + tmpCaption + ' for this patient?', MHA_Caption,
        mtConfirmation, [mbYes, mbNo], 0) = mrYes);

    end;

end;

procedure TfrmMHA_ASI_Main.mnuPrintReportClick(Sender: TObject);
begin
  if PageControl1.ActivePageIndex = 0 then
    begin
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintRichEdit(memASINarrativeReport, Patient.Name + '  SSN: '
        + Patient.FormattedSSN +
        '  Printed: ' + DateToStr(Date));
      frmMHA_Print.Free;
    end;
  if PageControl1.ActivePageIndex = 1 then
    begin
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintRichEdit(memASIItemReport, Patient.Name + '  SSN: ' +
        Patient.FormattedSSN +
        '  Printed: ' + DateToStr(Date));
      frmMHA_Print.Free;
    end;
end;

procedure TfrmMHA_ASI_Main.mnuPrintTableClick(Sender: TObject);
var
  PrintRect                   : TGridRect;
begin
  if PageControl1.ActivePageIndex = 2 then
    begin
      PrintRect.Left := 0;
      PrintRect.Top := 0;
      PrintRect.Right := grdTrends.ColCount;
      PrintRect.Bottom := grdTrends.RowCount;
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintGrid(grdTrends, Patient.Name + '  SSN: ' + Patient.FormattedSSN
        +
        '  ASI Trends  Printed: ' + DateToStr(Date),
        PrintRect);
      frmMHA_Print.Free;
    end;
  if PageControl1.ActivePageIndex = 3 then
    begin
      PrintRect.Left := 0;
      PrintRect.Top := 0;
      PrintRect.Right := grdScores.ColCount;
      PrintRect.Bottom := grdScores.RowCount;
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintGrid(grdScores, Patient.Name + '  SSN: ' + Patient.FormattedSSN
        +
        '  ASI Scores  Printed: ' + DateToStr(Date),
        PrintRect);
      frmMHA_Print.Free;
    end;
end;

procedure TfrmMHA_ASI_Main.mnuSaveTableClick(Sender: TObject);
begin
  with SaveDialog1 do
    case PageControl1.ActivePageIndex of
      2:
        begin
          FileName := 'ASI Trends.xls';
          Filter := 'Excel file (*xls)|*.xls';
          if Execute then
            begin
              grdTrends.cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
              grdTrends.SaveToXLS(FileName);
              grdTrends.cells[0, 0] := '';
            end;
        end;
      3:
        begin
          FileName := 'ASI Domain Scores.xls';
          Filter := 'Excel file (*xls)|*.xls';
          if Execute then
            begin
              grdScores.cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
              grdScores.SaveToXLS(FileName);
              grdScores.cells[0, 0] := '';
            end;
        end;
    end;
end;

procedure TfrmMHA_ASI_Main.mnuSaveReportClick(Sender: TObject);
begin
  with SaveDialog1 do
    case PageControl1.ActivePageIndex of
      0:
        begin
          FileName := 'ASI Narrative Report.rtf';
          Filter := 'Rich text file (*rtf)|*.rtf';
          if Execute then
            memASINarrativeReport.Lines.SaveToFile(FileName);
        end;
      1:
        begin
          FileName := 'ASI Item Report.rtf';
          Filter := 'Rich text file (*rtf)|*.rtf';
          if Execute then
            memASIItemReport.Lines.SaveToFile(FileName);
        end;
    end;
end;

procedure TfrmMHA_ASI_Main.mnuCopyReportClick(Sender: TObject);
var
  tmpMsg                      : string;
begin
  case PageControl1.ActivePageIndex of
    0:
      begin
        with memASINarrativeReport do
          begin
            SelectAll;
            CopyToClipboard;
            SelStart := 0;
            tmpMSG := 'The ASI narrative report has been copied to the Windows clipboard.'
              + CRLF + CRLF
              + 'If you like, you may paste it into a text document.'
          end;
      end;
    1:
      begin
        with memASIItemReport do
          begin
            SelectAll;
            CopyToClipboard;
            SelStart := 0;
            tmpMSG := 'The ASI item report has been copied to the Windows clipboard.'
              + CRLF + CRLF
              + 'If you like, you may paste it into a text document.'
          end;
      end;
  end;

  MsgDlgFrm(tmpMsg, MHA_Caption, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_ASI_Main.mnuCopyTableClick(Sender: TObject);
var
  tmpMsg                      : string;
begin
  case PageControl1.ActivePageIndex of
    2:
      begin
        grdTrends.Cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
        grdTrends.CopyToClipBoard;
        grdTrends.cells[0, 0] := '';

        tmpMSG := 'The ASI trends table has been copied to the Windows clipboard.'
          + CRLF + CRLF
          + 'If you like, you may paste it into a MS Excel table or a text document.'
      end;
    3:
      begin
        grdScores.Cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
        grdScores.CopyToClipBoard;
        grdScores.cells[0, 0] := '';
        tmpMSG := 'The ASI domain scores table has been copied to the Windows clipboard.'
          + CRLF + CRLF
          + 'If you like, you may paste it into a MS Excel table or a text document.'
      end;
  end;

  MsgDlgFrm(tmpMsg, MHA_Caption, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_ASI_Main.mnuShowGraphLabelsClick(Sender: TObject);
var
  t                           : integer;
begin
  mnuShowGraphLabels.Checked := not mnuShowGraphLabels.Checked;

  if mnuShowGraphLabels.Checked then
    begin
      if chrtScores <> nil then
        for t := 0 to chrtScores.SeriesCount - 1 do
          begin
            if chrtScores.Series[t] is TLineSeries then
              with (chrtScores.Series[t] as TLineSeries) do
                begin
                  Marks.Style := smsValue;
                  Marks.Visible := true;
                end
          end;

      if chrtTrends <> nil then
        for t := 0 to chrtTrends.SeriesCount - 1 do
          begin
            if chrtTrends.Series[t] is TLineSeries then
              with (chrtTrends.Series[t] as TLineSeries) do
                begin
                  Marks.Style := smsValue;
                  Marks.Visible := true;
                end;
          end;
    end
  else // Not checked
    begin
      if chrtScores <> nil then
        for t := 0 to chrtScores.SeriesCount - 1 do
          begin
            if chrtScores.Series[t] is TLineSeries then
              with (chrtScores.Series[t] as TLineSeries) do
                Marks.Visible := False;
          end;

      if chrtTrends <> nil then
        for t := 0 to chrtTrends.SeriesCount - 1 do
          begin
            if chrtTrends.Series[t] is TLineSeries then
              with (chrtTrends.Series[t] as TLineSeries) do
                Marks.Visible := False;
          end;
    end;
end;

procedure TfrmMHA_ASI_Main.imgBackupClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_ASI_Main.grdScoresRowChanging(Sender: TObject; OldRow,
  NewRow: Integer; var Allow: Boolean);
begin
  Allow := True;
  if OldRow <> NewRow then
    GraphScores(NewRow);
end;

procedure TfrmMHA_ASI_Main.grdTrendsRowChanging(Sender: TObject; OldRow,
  NewRow: Integer; var Allow: Boolean);
begin
  Allow := True;
  if NewRow <> OldRow then
    UpdateTrends(NewRow);
end;

procedure TfrmMHA_ASI_Main.grdASI1RowChanging(Sender: TObject; OldRow,
  NewRow: Integer; var Allow: Boolean);
begin
  if (NewRow = 0) or (OldRow = 0) then
    Exit;

  Allow := True;

  if NewRow <> OldRow then
    begin
      //grdASI1.Row := NewRow;
      grdASI2.SelectRows(NewRow, 1);
      UpdateInterviewGrids(NewRow);

    end;
end;

procedure TfrmMHA_ASI_Main.grdASI2RowChanging(Sender: TObject; OldRow,
  NewRow: Integer; var Allow: Boolean);
begin
  if (NewRow = 0) or (OldRow = 0) then
    Exit;

  Allow := True;

  if NewRow <> OldRow then
    begin
      grdASI1.SelectRows(NewRow, 1);
      UpdateInterviewGrids(NewRow);
    end;
end;

procedure TfrmMHA_ASI_Main.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;


// patch 108 508 compliance llh -- added so can add a message if screen reader in use
procedure TfrmMHA_ASI_Main.btnNewASIEnter(Sender: TObject);
begin
  if not gvUseScreenReader then exit ;

  MsgDlgFrm('Press Enter to add a new A S I, otherwise Tab to continue.',
          MHA_CAPTION, mtInformation, [mbOK], 0);
  exit;
end;

//patch 108 added to make MHA 508 compliant llh
procedure TfrmMHA_ASI_Main.mnuPopNewExitClick(Sender: TObject);
begin
   exit ;
end;

procedure TfrmMHA_ASI_Main.btnScrRdrExitClick(Sender: TObject);
begin
  close;
end;

end.

