unit fMHA_EditGAF;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  fIA_dialogs, Dialogs,
  StdCtrls,
  Mask,
  ExtCtrls,
  RzPanel,
  RzLabel,
  Buttons,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  Spin;

type

  TfrmMHA_EditGAF = class(TForm)
    pnlButton: TPanel;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    btnOK: TJvXPButton;
    btnCancel: TJvXPButton;
    cbxDelete: TCheckBox;
    cbxChange: TCheckBox;
    lblInstruction: TLabel;
    lblRating: TLabel;
    spnRating: TSpinEdit;
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ConfigureForm;
    procedure spnRatingChange(Sender: TObject);
    procedure cbxChangeClick(Sender: TObject);
    procedure cbxDeleteClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    function RatingHasChanged: BOOLEAN;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMHA_EditGAF              : TfrmMHA_EditGAF;

implementation

uses
  uIA_Const,
  uIA_GUIControl,
  uMHA_Registry,
  uIA_Patient,
  uMHA_GAF,
  uMHA_GAF_OPS;

{$R *.DFM}

var
  lvInitialize                : Boolean;


procedure TfrmMHA_EditGAF.FormCreate(Sender: TObject);
begin
  lvInitialize := True;
  Position := poDesigned;
  //Position := poOwnerFormCenter;

  ConfigureForm;
  ShowModal;
end;


procedure TfrmMHA_EditGAF.FormShow(Sender: TObject);
begin
  lvInitialize := False;
  Screen.Cursor := crDefault;
  ActiveControl := cbxDelete;
end;

procedure TfrmMHA_EditGAF.ConfigureForm;
var
  TempHeight                  : Integer;
begin
  // See FormResize for left settings.
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;

      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Width := GetWidth(5 * ButtonWidthNormal);

      TempHeight := 3 * TextHeight('Yy', gvFont) div 2;
      Height := GetHeight(pnlHeaderHeight + ((3 * ButtonHeight) div 2) +
        9 * TempHeight);
      Left := gvLeft + (GetLeft(Width) div 2);
      Top := gvTop + (GetTop(Height) div 2);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      lblInstruction.Height := 2 * TempHeight;
      lblInstruction.Top := pnlHeaderHeight + TempHeight;
      lblInstruction.Width := ClientWidth;

      cbxDelete.Height := TempHeight;
      cbxDelete.Width := ButtonWidth(cbxDelete.caption + 'XXXXX');
      cbxDelete.Left := 20;
      cbxDelete.Top := 3 * TempHeight + pnlHeaderHeight;

      cbxChange.Height := TempHeight;
      cbxChange.Width := ButtonWidth(cbxChange.caption + 'XXXXX');
      cbxChange.top := cbxDelete.Top;

      spnRating.Height := TempHeight;
      spnRating.Width := TextWidth('XXXXXXX', gvFont);
      spnRating.Top := 5 * TempHeight + pnlHeaderHeight;
      spnRating.Enabled := false;

      lblRating.Top := spnRating.Top;

      if gvUseScreenReader then
        lblRating.Visible := True
      else
        lblRating.Visible := False;

      pnlHeader.Height := pnlHeaderHeight;
      lblHeader.Font.Size := lblHeaderFontSize;
      lblHeader.Caption := '  Edit GAF rating';

      pnlButton.Height := (3 * ButtonHeight) div 2;
      btnOK.Top := (pnlButton.Height - ButtonHeight) div 2;
      btnOK.Height := ButtonHeight;
      btnOK.Width := ButtonWidthNormal;
      btnCancel.Top := btnOK.Top;
      btnCancel.Height := ButtonHeight;
      btnCancel.Width := ButtonWidthNormal;

      lblInstruction.Caption :=
        '   Specify the editing action you wish to take for ' + CRLF +
        '   the rating: ' + IntToStr(ActiveGAF.Rating) + ' on ' +
        ActiveGAF.DateString;

      spnRating.Value := ActiveGAF.Rating;
      cbxDelete.Checked := false;
      cbxChange.Checked := false;

      if gvUseScreenReader then
        begin
          Left := 0;
          Width := Screen.Width;
          //btnOK.caption := btnOK.Caption + ' button';
          //btnCancel.caption := btnCancel.Caption + ' button';
          Caption := '   Delete or change rating of: ' +
            IntToStr(ActiveGAF.Rating) + ' on ' + ActiveGAF.DateString;
        end;
    end;
end;

procedure TfrmMHA_EditGAF.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_EditGAF.btnOKClick(Sender: TObject);
var
  Tempstr                     : string;
begin
  TempStr := '';

  if cbxDelete.Checked then
    begin
      TempStr := GAF_OPS.Delete(ActiveGAF.IENS);
      if TempStr = DATA then
        ShowMessage('GAF deleted.')
      else
        ShowMessage('GAF not deleted. ' + #13 + TempStr);
    end;

  if cbxChange.Checked then
    begin
      // This has self contained error reporting.
      if GAF_OPS.SaveEdit(ActiveGAF.IENS, StrToInt(spnRating.Text)) then
        ShowMessage('GAF changed.');
    end;

  Close;
end;

function TfrmMHA_EditGAF.RatingHasChanged: BOOLEAN;
begin
  result := False;
  if spnRating.Text <> '' then
    Result := not (ActiveGAF.Rating = spnRating.Value);

end;

procedure TfrmMHA_EditGAF.spnRatingChange(Sender: TObject);
begin
  btnOK.Enabled := RatingHasChanged;
end;

procedure TfrmMHA_EditGAF.cbxChangeClick(Sender: TObject);
begin
  if cbxChange.checked then
    begin
      spnRating.Enabled := true;
      cbxDelete.checked := false;
      btnOK.Enabled := RatingHasChanged;
      spnRating.SetFocus;
    end
  else
    begin
      spnRating.Enabled := false;
      cbxDelete.checked := false;
    end;
end;

procedure TfrmMHA_EditGAF.cbxDeleteClick(Sender: TObject);
begin
  if cbxDelete.checked then
    begin
      spnRating.Enabled := false;
      cbxChange.checked := false;
      btnOK.Enabled := True;
    end
  else
    begin
      btnOK.Enabled := false;
    end;
end;

procedure TfrmMHA_EditGAF.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;
end;


procedure TfrmMHA_EditGAF.FormResize(Sender: TObject);
begin
  lblInstruction.Left := (ClientWidth - lblInstruction.Width) div 2;
  cbxChange.left := ClientWidth div 2;
  spnRating.Left := ClientWidth div 2;
  lblRating.Left := spnRating.Left - lblRating.Width - 5;
  btnOK.Left := pnlButton.Width - btnOK.Width - btnOK.Width div 3;
  btnCancel.Left := btnOK.Width div 3;
end;

end.

