
unit uMHA_DLL_GAF_IO;

interface

uses
  TRPCb;


function WriteNewGAFRating(Broker: TRPCBroker; aDFN, aDUZ,
  aDate, aGAFScore: string): string;
function ReadPreviousGAFRatings(Broker: TRPCBroker; const aDFN: string): string;

implementation

uses
  SysUtils,
  Classes,
  dialogs,
  Diaccess,
  uIA_Utils,
  uIA_Const,
  uMHA_DLL_Const,
  uMHA_DLL_GAF;

  (*
procedure DeleteGAF(Broker: TRPCBroker; ADFN: string);
var
  FMFile, tmpIENS: string;
begin

        {Deletes record using ^DIK}
        FMFile := '627.8';
        tmpIENS := GAF.IENS + ',';

        if (ParamOK(FMFile)) and (ParamOK(tmpIENS)) then
          with Broker do
          begin
            ClearParameters := True;
            ClearResults := True;
            CreateContext('YS BROKER1');
            RemoteProcedure := 'DDR DELETE ENTRY';

            with Param[0] do
            begin
              PType := list;
              Mult['"FILE"'] := FMFile;
              Mult['"IENS"'] := tmpIENS;
            end; //with DataModule1...

            Call;

            // Make log file entry
            if results.count > 0 then
              //make sure there is at least one returned value
              if results.count > 1 then // Are there two or more values?
                DataModule1.StGeneralLog1.WriteLogString('DDR DELETE ENTRY: DeleteGAF' + #13#10 +
                  #9 + '   ' + DataModule1.RPCBroker1.Results[0] + #13#10 +
                  #9 + '   ' + DataModule1.RPCBroker1.Results[1])
              else
                DataModule1.StGeneralLog1.WriteLogString('DDR DELETE ENTRY: DeleteGAF' + #13#10 +
                  #9 + '   ' + DataModule1.RPCBroker1.Results[0]);

          end; //if...

end; *)

function WriteNewGAFRating(Broker: TRPCBroker; aDFN, aDUZ,
  aDate, // FileMan format
  aGAFScore: string): string;
var
  FMDate                      : Double;
begin
  result := 'ERROR: Blank parameter for DFN, DUZ or date.';
  if (aDFN = '') or (aDUZ = '') or (aDate = '') then
    Exit;

  FMDate := StrToFloat(aDate);

  with Broker do
    begin
      ClearResults := True;
      ClearParameters := True;
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTAPI NEW GAF';
      Param[0].Mult['"DFN"'] := aDFN;
      Param[0].Mult['"GAF"'] := aGAFScore;
      // Date needs to be in MM/DD/YYYY format
      Param[0].Mult['"DATE"'] := DateToStr(FMDateTimeToDateTime(FMDate));
      Param[0].Mult['"STAFF"'] := aDUZ;
      Param[0].PType := List;
      Call;

      if results[0] = '[DATA]' then
        result := OK
      else
        result := results[0];

      CreateContext('OR CPRS GUI CHART');
    end; //with Broker
end;

(*
procedure WriteEditedGAFRating(ADFN: string);
var
  strScore: string;
begin
  strScore := IntToStr(GAF.Rating);

  case DataBaseMode of
    dbVista:
      begin
        DataModule1.FMFiler1.RPCBroker := DataModule1.RPCBroker1;
        DataModule1.FMValidator1.RPCBroker := DataModule1.RPCBroker1;

        //Validate the value of the field
        DataModule1.FMValidator1.Setup('627.8', GAF.IENS, '65', strScore);
        if not DataModule1.FMValidator1.Validate then
          DataModule1.FMValidator1.DisplayErrors
        else
        begin {file}
          //Put validated field for record on Filer's change list
          DataModule1.FMFiler1.AddFDA('627.8', GAF.IENS, '65', strScore);
          //(FileNumber, IENS, FieldNumber, NewScore)
          //File record
          if not DataModule1.FMFiler1.Update then
            DataModule1.FMFiler1.DisplayErrors;
        end;
      end; //casedbVista
  end; //case DatabaseMode
end;

procedure WriteGAFEnteredInError(ADFN: string; AUserName: string);
var
  ErrorMsg, YS: string;
  i: integer;
begin

  ErrorMsg := 'Error: entered in error noted on ' // ex. FEB 7,2002@09:45:03
  + FormatFMDateTime('mmm dd, yyyy' + ' @ ' + 'hh:mm:ss', DateTimeToFMDateTime(Now))
    + ' by ' + AUserName; // ex. MHPROVIDER,ONE

  case DataBaseMode of
    dbVista:
      begin

        ErrorMsg := StringToPieces(ErrorMsg, U, 200);

        with DataModule1.RPCBroker1 do
        begin
          ClearResults := True;
          ClearParameters := True;
          CreateContext('YS BROKER1');
          RemoteProcedure := 'YTQ WP FILER';
          Param[0].Mult['"FILEN"'] := '627.8';
          Param[0].Mult['"IEN"'] := GAF.IENS;
          Param[0].Mult['"FIELD"'] := '80';

          for i := 1 to NumberOfPieces(ErrorMsg, U) do
          begin
            YS := '"' + IntToStr(i) + '"';
            Param[0].Mult[YS] := Piece(ErrorMsg, U, i);
          end;

          Param[0].PType := List;

          Call;

          // Make log file entry
          if results.count > 0 then
            //make sure there is at least one returned value
            if results.count > 1 then // Are there two or more values?
              DataModule1.StGeneralLog1.WriteLogString('YTQ WP FILER: WriteGAFEnteredInError' + #13#10 +
                #9 + '   ' + DataModule1.RPCBroker1.Results[0] + #13#10 +
                #9 + '   ' + DataModule1.RPCBroker1.Results[1])
            else
              DataModule1.StGeneralLog1.WriteLogString('YTQ WP FILER: WriteGAFEnteredInError' + #13#10 +
                #9 + '   ' + DataModule1.RPCBroker1.Results[0]);
        end;

      end; //dbVista
  end; //case DatabaseMode
end;   *)

function ReadPreviousGAFRatings(Broker: TRPCBroker; const aDFN: string): string;

  function ParseErrorMsg(AString: string): string;
  begin
    //Error: entered in error noted on Jan 07,2004@07:01:29 by MHPROVIDER,ONE
    Result := UpperCase(Piece(AString, ':', 1));
  end;

var
  tmpGAF, tmpResult           : string;
  i                           : integer;

begin
  tmpGAF := '';
  tmpResult := '';


  with Broker do
    begin
      CreateContext('YS BROKER1');
      ClearParameters := True;
      ClearResults := True;
      RemoteProcedure := 'YTQ GAF HX';
      Param[0].Mult['"DFN"'] := aDFN;
          // Possible parameters, but not used
          // Param[0].Mult['"END"'] := DateToStr(Date);// Date of last GAF requested [optional]
          // Param[0].Mult['"BEGIN"'] := '01/01/1994';// Date of first GAF requested [optional]
          // Param[0].Mult['"LIMIT"'] := '20'; // To limit output to the last x diagnosis
      Param[0].PType := List;
      Call;

          // Sample return:
          // [DATA]
          // 11358=01/12/2004^85^11678^MHPROVIDER,ONE^
          // 11355=01/06/2004^45^5325^MHPROVIDER,TWO^
          // 11356=01/06/2004^85^5325^MHPROVIDER,TWO^
          // 11357=01/01/2004^25^5325^MHPROVIDER,TWO^Error: entered in error noted on Jan 07,2004@07:01:29 by MHPROVIDER,TWO

      if Results[0] = DATA then
        begin

          for i := 1 to Results.Count - 1 do
            begin
              tmpGAF := Pieces(Results[i], U, 1, 4) + U
                + ParseErrorMsg(Piece(Results[i], U, 5));
              tmpResult := tmpResult + tmpGAF + RECORD_END;
            end;
        end
      else
        tmpResult := BAD_DATA + RECORD_END;

    end;


  Result := DropTrailer(tmpResult);

end;

end.

