unit uMHA_AUX_VA_SAT;

interface

uses
  DateUtils,
  SysUtils;

function Verify_VA_SAT(InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;


implementation

uses
  uMHA_AUX_Const,
  fIA_dialogs,
  uMHA_AUX_Utils;


function Verify_VA_SAT(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  Alc1,
    Alc2,
    Sub1,
    Sub2,
    Count, i                  : Integer;
  AlcDays1,
    AlcDays2,
    SubDays1,
    SubDays2,
    TempStr                   : string;

begin

  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems
  // Remeber to add a "V" to result if there is a message for user. This
  // separates multiple messages.
  Count := NumberOfPieces(AnswerString, V);
  Sub1 := 0;
  Alc1 := 0;

  AlcDays1 := '';
  AlcDays2 := '';
  SubDays1 := '';
  SubDays2 := '';

  if Count < 1 then
    Exit;

  for i := 1 to Count - 1 do
    begin

      if i = 6 then
        begin
          TempStr := Piece(AnswerString, V, i);
          AlcDays1 := Piece(Piece(TempStr, EQ, 2), U, 1);
          Alc1 := StrToIntDef(AlcDays1, 0);
        end;

      if i = 7 then
        begin
          TempStr := Piece(AnswerString, V, i);
          AlcDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if AlcDays2 = '1156' then
            Alc2 := 0
          else
            Alc2 := StrToIntDef(AlcDays2, 0);
          if Alc1 < Alc2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 4 should be equal to, or more than, ' +
                'the number of days in Question 5.' + V;
            end;
        end;

      if i = 8 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays1 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays1 = '1156' then
            Sub1 := 0
          else
            Sub1 := StrToIntDef(SubDays1, 0);
        end;

      if i = 9 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7-A should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

      if i = 10 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);

          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7-B should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

      if i = 11 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7-C should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

      if i = 12 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7-D should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

      if i = 13 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7-E should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

      if i = 14 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7F should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

      if i = 15 then
        begin
          TempStr := Piece(AnswerString, V, i);
          SubDays2 := Piece(Piece(TempStr, EQ, 2), U, 1);
          if SubDays2 = '1156' then
            Sub2 := 0
          else
            Sub2 := StrToIntDef(SubDays2, 0);
          if Sub1 < Sub2 then
            begin
              Result := Result +
                'There is an inconsistency: The number of days ' +
                'entered in Question 7G should be equal to, or less than, ' +
                'the number of days in Question 6.' + V;
            end;
        end;

    end; // for i
end;

end.

 