unit uIA_Build;

interface

uses
  Windows,
  Messages,
  classes,
  SysUtils,
  Graphics,
  Controls,
  Forms,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  Mask,
  RzPanel,
  RzRadGrp,
  Menus,
  RzChkLst,
  RzLstBox,
  RzSpnEdt,
  Buttons,
  ExTrackBar,
  JvExMask,
  JvToolEdit,
  JvCheckedMaskEdit,
  JvDatePickerEdit,
  JvValidateEdit,
  ORCtrls,
  fIA_Dialogs,
  uIA_Display,
  uIA_Question;

procedure Build_ScrollBox(ScrollBoxIn: TScrollBox; aParent: TForm);

procedure Build_Title(LabelIn: TLabel; Display: TDisplay;
  TagIn: integer;
  StringIn, HintIn: string; WhichScrollBox: TScrollBox);

procedure Build_Section(LabelIn: TLabel; Display: TDisplay;
  TagIn: integer;
  StringIn: string; WhichScrollBox: TScrollBox);

procedure Build_Instructions(LabelIn: TLabel; Display: TDisplay;
  TagIn: integer;
  StringIn: string; WhichScrollBox: TScrollBox);

function Build_Label(LabelIn: TLabel; Display, AnswerDisplay: TDisplay;
  StringIn, HintIn: string; TagIn: Integer; AResponseType: TResponseType;
  WhichScrollBox: TScrollBox): integer;

procedure Build_RadioGroup(Radio: TRzRadioGroup;
  CaptionIn, HintIn: string;
  TagIn: Integer;
  IsLegacy: Boolean;
  Display,
  AnswerDisplay: TDisplay;
  WhichScrollBox: TScrollBox;
  AItems: TStringList);

procedure Build_CheckListBox(CheckList: TRzCheckList; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);

procedure Build_ListBox(ListBox: TRzListBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);

procedure Build_ComboBox(ComboBox: TComboBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);

procedure Build_TrackBar(TrackBar: TExTrackBar; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn, MinIn, MaxIn: integer; WhichScrollBox: TScrollBox);

procedure Build_TrackLabel2(LabelIn: TLabel; AnswerDisplay: TDisplay;
  TagIn: integer;
  WhichScrollBox: TScrollBox;
  Choices: TStringList);

procedure Build_Faux_TrackBar(ListBox: TListBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);

procedure Build_Date(ThisDate: TJvDatePickerEdit; aAnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);

procedure Build_Edit(Edit: TEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);

procedure Build_StaffComboBox(StaffComboBox: TORComboBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);

procedure Build_ConsultComboBox(ConsultComboBox: TORComboBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);

procedure Build_MaskEdit(MaskEdit: TMaskEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);

procedure Build_Memo(MemoIn: TMemo; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);

procedure Build_SpinEdit(SpinEdit: TRzSpinEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn, aMin, aMax: integer; WhichKind: TResponseType;
  WhichScrollBox: TScrollBox);

procedure Build_Currency(Currency: TJvValidateEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn, aMin, aMax: integer; WhichScrollBox: TScrollBox);

//procedure Build_Form(WhichForm: TForm;
//  WhichDisplay: TDisplay;
//  WhichScrollBox: TScrollBox;
//  ScrollBarWidthWS: integer);

procedure Build_Items(Designator: TChoiceIdentifier;
  var StringListIn: TStringList);

function Build_508IntroCaption(GroupBoxIn: TGroupBox;
  Display: TDisplay;
  StringIn: string;
  TagIn: Integer;
  AResponseType: TResponseType;
  WhichScrollBox: TScrollBox): Integer;

implementation

uses
  uIA_Const,
  uIA_Utils,
  uIA_GUIControl,
  uIA_Introduction,
  uIA_SectionLabel;


function GetWidth(StringIn: string): integer;
var
  i                           : Integer;
  TempStr                     : string;
  Ok                          : Boolean;
begin
  Result := DEFAULT_EDIT_BOX_WIDTH;
  TempStr := Piece(StringIn, DELIMITER, 1);
  if (TempStr = 'NA') or (TempStr = '') then
    Exit;
  Ok := true;
  for i := 1 to length(TempStr) do
    if not CharInSet(TempStr[i], ['0'..'9']) then
      Ok := False;
  if Ok then
    result := strtoint(TempStr);
  if result <= 0 then
    result := DEFAULT_EDIT_BOX_WIDTH;
end;


(*function GetSameLine(StringIn: string): Char;
// Input is Answer.Mask. GetSameLine can be "S" = same line or
// "N" = next line.
var
  TempStr                     : string;
begin
  Result := SAME_LINE; // Same line
  TempStr := Piece(StringIn, DELIMITER, 3);

  if (Length(Trim(TempStr)) > 1) or (Length(Trim(TempStr)) < 1) then
    exit;
  if (TempStr[1] = NEXT_LINE) or (TempStr[1] = SAME_LINE) then
    Result := TempStr[1];
end; *)

(*function GetMemoSameLine(StringIn: string): Char;
// Input is Answer.Mask. GetSameLine can be "S" = same line or
// "N" = next line.
var
  TempStr                     : string;
begin
  Result := NEXT_LINE; // Next line
  TempStr := Piece(StringIn, DELIMITER, 3);

  if (Length(Trim(TempStr)) > 1) or (Length(Trim(TempStr)) < 1) then
    exit;
  if (TempStr[1] = NEXT_LINE) or (TempStr[1] = SAME_LINE) then
    Result := TempStr[1];
end;*)

procedure Build_Items(Designator: TChoiceIdentifier;
  var StringListIn: TStringList);
var
  i                           : Integer;
  TempSL                      : TStringList;
begin
  if StringListIn.Count = 0 then
    Exit;

  TempSL := TStringList.Create;

  for i := 0 to StringListIn.Count - 1 do
    begin

      case Designator of
        ciNone: TempSL.Add(StringListIn[i]);
        ciZeroBased: TempSL.Add(inttostr(i) + '. ' + StringListIn[i]);
        ciOneBased: TempSL.Add(inttostr(i + 1) + '. ' + StringListIn[i]);
//        ciNone: TempSL.Add(Piece(StringListIn[i], U, 3));
//        ciZeroBased: TempSL.Add(inttostr(i) + '. ' + Piece(StringListIn[i], U, 3));
//        ciOneBased: TempSL.Add(inttostr(i + 1) + '. ' + Piece(StringListIn[i], U, 3));
      end; //case Question.ChoiceIdentifier
    end;

  StringListIn.Clear;
  StringListIn.AddStrings(TempSL);
  TempSL.Free;
end;

function Build_Label(LabelIn: TLabel; Display, AnswerDisplay: TDisplay;
  StringIn, HintIn: string; TagIn: Integer; AResponseType: TResponseType;
  WhichScrollBox: TScrollBox): integer;
begin

  with LabelIn do
    begin
      Parent := WhichScrollBox;
      if AResponseType = rtTrackBar then
        Name := cTrackBarLabel1 + IntToStr(gvQuestionOrder)
      else
        Name := cLabel + IntToStr(gvQuestionOrder);

      Tag := TagIn;
      AutoSize := False;
      Top := gvQuestionTop;
      Left := Display.DisplayLeft;
      if Left < 2 then
        Left := 2;

      if gvUseDesignFont then
        Font.Assign(Display.DisplayFont)
      else
        begin
          Font.Assign(gvFont);
          Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end;

      if (not AnswerDisplay.DisplaySameLine) or // Component on next line
        (AResponseType = rtTrackBar) or
        (not gvUseDesignFont) then
        Width := WhichScrollBox.Width - Left - gvScrollBarWidthWS
      else
        Width := AnswerDisplay.DisplayLeft - (2 * Left);

      if Width <= 0 then
        Width := 1;

      Hint := HintIn;
      Alignment := Display.DisplayAlignment;
      WordWrap := True;
      Caption := StringReplace(StringIn, CARRIAGE_RETURN_MARKER, CRLF, [rfReplaceAll]);

      // Check for wrapping of the caption
      Height := GUI_Control.GetWrapHeight(Caption, Width, Font);

      if Height > GUI_Control.GetStandardHeight(Font) then
        Layout := tlTop
      else
        Layout := tlCenter;

      Result := Height;
    end;
end;

procedure Build_Title(LabelIn: TLabel; Display: TDisplay;
  TagIn: integer;
  StringIn, HintIn: string; WhichScrollBox: TScrollBox);
begin
  with LabelIn do
    begin
      Parent := WhichScrollBox;
      Name := cTitle + IntToStr(gvQuestionOrder);
      //TabStop := True;
      //TabOrder := gvQuestionOrder;
      Tag := TagIn;
      AutoSize := False;
      Top := gvQuestionTop;
      Left := Display.DisplayLeft;
      if Left < 2 then
        Left := 2;
      Width := WhichScrollBox.Width - Left - gvScrollBarWidthWS;
      if gvUseDesignFont then
        Font.Assign(Display.DisplayFont)
      else
        Font.Assign(gvFont);
      Hint := HintIn;
      Alignment := Display.DisplayAlignment;
      WordWrap := True;
      Caption := StringIn;
      // Check for wrapping the caption
      Height := GUI_Control.GetWrapHeight(Caption, Width, Font);
      if Height > GUI_Control.GetStandardHeight(Font) then
        Layout := tlTop
      else
        Layout := tlCenter;
      gvQuestionTop := gvQuestionTop + Height;
    end;
end;

procedure Build_Instructions(LabelIn: TLabel; Display: TDisplay;
  TagIn: integer;
  StringIn: string; WhichScrollBox: TScrollBox);
begin

  with LabelIn do
    begin
      Parent := WhichScrollBox;
      Name := cIntroduction + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      AutoSize := False;
      Caption := StringReplace(StringIn, CARRIAGE_RETURN_MARKER, CRLF, [rfReplaceAll]);
      Top := gvQuestionTop;
      Left := Display.DisplayLeft;
      if Left < 2 then
        Left := 2;
      Alignment := Display.DisplayAlignment;
      if gvUseDesignFont then
        Font.Assign(Display.DisplayFont)
      else
        Font.Assign(gvFont);
      Width := WhichScrollBox.Width - Left - gvScrollBarWidthWS;
      WordWrap := True;

      // Check for wrapping the caption
      Height := GUI_Control.GetWrapHeight(Caption, Width, Font);

      if Height > GUI_Control.GetStandardHeight(Font) then
        Layout := tlTop
      else
        Layout := tlCenter;
      gvQuestionTop := gvQuestionTop + Height;
    end;
end;

procedure Build_Section(LabelIn: TLabel; Display: TDisplay;
  TagIn: integer;
  StringIn: string; WhichScrollBox: TScrollBox);
begin
  with LabelIn do
    begin
      Parent := WhichScrollBox;
      Name := cSection + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      AutoSize := False;
      Top := gvQuestionTop;
      Left := Display.DisplayLeft;
      if Left < 2 then
        Left := 2;
      Alignment := Display.DisplayAlignment;
      Caption := StringIn;
      Width := WhichScrollBox.Width - Left - gvScrollBarWidthWS;
      if gvUseDesignFont then
        Font.Assign(Display.DisplayFont)
      else
        Font.Assign(gvFont);
      // Check for wrapping the caption
      Height := GUI_Control.GetWrapHeight(Caption, Width, Font);
      if Height > GUI_Control.GetStandardHeight(Font) then
        Layout := tlTop
      else
        Layout := tlCenter;
      gvQuestionTop := gvQuestionTop + Height;
    end;
end;

procedure Build_RadioGroup(Radio: TRzRadioGroup;
  CaptionIn, HintIn: string;
  TagIn: Integer;
  IsLegacy: Boolean;
  Display,
  AnswerDisplay: TDisplay;
  WhichScrollBox: TScrollBox;
  AItems: TStringList);
var
  lColumns,
    lItemHeight,
    lHeight,
    lStartYPos                : Integer;
begin
  with Radio do
    begin
      Parent := WhichScrollBox;
      Name := cRadioGroup + IntToStr(gvQuestionOrder);
      GroupStyle := gsCustom;
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;

      Top := gvQuestionTop;
      Left := Display.DisplayLeft;
      if Left < 2 then
        Left := 2;

      if gvUseDesignFont then
        begin
          Font.Assign(Display.DisplayFont);
          Width := GetWidth(AnswerDisplay.DisplayMask);
          if (Width = DEFAULT_EDIT_BOX_WIDTH) or
            (Width = 0) then
            Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end
      else
        begin
          Font.Assign(gvFont);
          Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end;

      ParentColor := false;
      ShowHint := True;
      Hint := HintIn;
      BorderSides := [];
      SpaceEvenly := True; // allows wrapping of items.
      //ThemeAware := True;  // KCM -- exists for button but not for group
      UseCustomGlyphs := False;

      Caption := StringReplace(CaptionIn, CARRIAGE_RETURN_MARKER, CRLF, [rfReplaceAll]);
      Items.AddStrings(AItems);
      Columns := AnswerDisplay.DisplayColumns;
      VerticalSpacing := GUI_Control.TextHeight('Yy', Font) div 4;

//      if Instrument.IsLegacy then // Indent multi-choice items
//        StartXPos := 3 * gvQuestionLeft
//      else
//        StartXPos := AnswerDisplay.DisplayLeft;

      lColumns := Columns;
      lItemHeight := ItemHeight;
      lHeight := Height;
      lStartYPos := StartYPos;

      GUI_Control.ConfigureRadioGroup(Caption, Items, Font, ItemFont, Width,
        StartXPos, lColumns, lItemHeight, lHeight, lStartYPos);
      Columns := lColumns;
      ItemHeight := lItemHeight;
      StartYPos := lStartYPos;
      Height := lHeight;
      gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_ComboBox(ComboBox: TComboBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);
begin

  with ComboBox do
    begin
      Parent := WhichScrollBox;
      Name := cComboBox + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Text := '';
      Top := gvQuestionTop;
      Width := GetWidth(AnswerDisplay.DisplayMask);
      if (Width = DEFAULT_EDIT_BOX_WIDTH) or
        (Width = 0) then
        Width := 3 * gvDefaultEditWidth div 2;
      Left := AnswerDisplay.DisplayLeft;
      //AutoSize := False;
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);

      Height := GUI_Control.GetStandardHeight(Font);
      ShowHint := True;
      Hint := HintIn;
      Style := csDropDownList;
      ItemIndex := -1;
      ItemHeight := GUI_Control.GetItemHeight(Font);
      Sorted := false;

      Items.AddStrings(AItems);

      DropDownCount := 8;
      if Items.Count < 13 then
        DropDownCount := Items.Count;

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_CheckListBox(CheckList: TRzCheckList; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);
begin
  with CheckList do
    begin
      Parent := WhichScrollBox;
      //Style := lbOwnerDrawFixed;
      Name := cCheckList + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      TabOrder := gvQuestionOrder;
      TabOnEnter := False;
      TabStop := True;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;

      if gvUseDesignFont then
        begin
          Font.Assign(AnswerDisplay.DisplayFont);
          Width := GetWidth(AnswerDisplay.DisplayMask);
          if (Width = DEFAULT_EDIT_BOX_WIDTH) or
            (Width = 0) then
            Width := 3 * gvDefaultEditWidth div 2;
        end
      else
        begin
          Font.Assign(gvFont);
          Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end;
      BorderStyle := bsSingle;
      Color := clWindow;
      Sorted := False;
      Hint := HintIn;
      ShowHint := True;
      MultiSelect := True;
      ExtendedSelect := True; // Allow shift key to work when selecting many items.
      IntegralHeight := false;
      ItemIndex := -1;
      //ItemHeight := GUI_Control.GetItemHeight(Font);
      ToggleOnItemClick := True;
      UseCustomGlyphs := False;
      Items.AddStrings(AItems);
      Columns := AnswerDisplay.DisplayColumns;
      if Columns <= 0 then
        Columns := 1;

      Height := GUI_Control.HeightListBox(Width, Columns, Font,
        AItems);

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_ListBox(ListBox: TRzListBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);
begin
  with ListBox do
    begin
      Parent := WhichScrollBox;
      Style := lbOwnerDrawFixed;
      Name := cListBox + IntToStr(gvQuestionOrder);
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Tag := TagIn;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;

      if gvUseDesignFont then
        begin
          Font.Assign(AnswerDisplay.DisplayFont);
          Width := GetWidth(AnswerDisplay.DisplayMask);
          if (Width = DEFAULT_EDIT_BOX_WIDTH) or
            (Width = 0) then
            Width := 3 * gvDefaultEditWidth div 2;
        end
      else
        begin
          Font.Assign(gvFont);
          Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end;

      ShowHint := True;
      Hint := HintIn;
      BorderStyle := bsSingle;
      Color := clWindow;
      Sorted := False;
      MultiSelect := False;
      IntegralHeight := false;
      ItemIndex := -1;
      ItemHeight := GUI_Control.GetItemHeight(Font);
      TabOnEnter := False;
      //ToggleOnItemClick := true;
      //UseCustomGlyphs := False;
      Items.AddStrings(AItems);
      Columns := AnswerDisplay.DisplayColumns;
      if Columns <= 0 then
        Columns := 1;
      Height := GUI_Control.HeightListBox(Width, Columns, Font,
        AItems);

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_StaffComboBox(StaffComboBox: TORComboBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);
begin
  with StaffComboBox do
    begin
      Parent := WhichScrollBox;
      Name := 'cbs' + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;
      Text := '';
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;
      Width := GetWidth(AnswerDisplay.DisplayMask);
      if (Width = DEFAULT_EDIT_BOX_WIDTH) or
        (Width = 0) then
        Width := 3 * gvDefaultEditWidth div 2;
      //AutoSize := False;
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Height := GUI_Control.GetStandardHeight(Font);
      CheckBoxes := False;
      CheckEntireLine := False;
      LongList := True;
      HideSynonyms := True;
      Sorted := True;
      Style := orcsDropDown;
      Pieces := '2';

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;

    end;
end;

procedure Build_ConsultComboBox(ConsultComboBox: TORComboBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);
begin
  with ConsultComboBox do
    begin
      Parent := WhichScrollBox;
      Name := 'cbc' + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;
      Text := '';
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;
      Width := GetWidth(AnswerDisplay.DisplayMask);
      if (Width = DEFAULT_EDIT_BOX_WIDTH) or
        (Width = 0) then
        Width := 3 * gvDefaultEditWidth div 2;

      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Height := GUI_Control.GetStandardHeight(Font);

      Sorted := false;
      AutoSelect := False;
      CheckBoxes := False;
      CheckEntireLine := true;
      ListItemsOnly := true;
      LongList := true;
      HideSynonyms := true; //allowed on LongList = true;
      Style := orcsDropDown;
      Delimiter := '^';
      LookupPiece := 0;
      ItemTipEnable := False;

      UniqueAutoComplete := True;

      Pieces := '2,3,7';

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;

    end;
end;

procedure Build_TrackLabel2(LabelIn: TLabel; AnswerDisplay: TDisplay;
  TagIn: integer;
  WhichScrollBox: TScrollBox;
  Choices: TStringList);
// Labels for the slider-scale
var
  i                           : Integer;
  TempStr                     : string;
begin
  with LabelIn do
    begin
      Parent := WhichScrollBox;
      Name := cTrackBarLabel2 + IntToStr(gvQuestionOrder);
      AutoSize := False;
      Top := gvQuestionTop;
      Tag := TagIn;
      Layout := tlCenter;
      Left := AnswerDisplay.DisplayLeft;
      if Left < gvTrackBarIndent div 2 then
        Left := gvTrackBarIndent div 2;
      //Width := GetWidth(Display.DisplayMask);
      //if Width = DEFAULT_EDIT_BOX_WIDTH then
      Width := WhichScrollBox.Width - gvScrollBarWidthWS - (2 * Left);
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Height := GUI_Control.GetTrackBarLabel2Height(Font);
      Alignment := taLeftJustify;

      WordWrap := False;
      TempStr := '';
      // Accept High & Low descriptions or High, Medium & Low.
      if ((Choices.Count > 1) or
        (Choices.Count < 4)) then
        begin
          for i := 0 to Choices.Count - 1 do
            TempStr := TempStr + Choices[i] + DELIMITER;
        end;

      Caption := GUI_Control.ExpandTrackLabels(Width, TempStr, Font);
      if Caption = '' then
        Height := 0;
      gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_TrackBar(TrackBar: TExTrackBar; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn, MinIn, MaxIn: integer; WhichScrollBox: TScrollBox);
begin
  with TrackBar do
    begin
      Parent := WhichScrollBox;
      Name := cTrackBar + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      gvQuestionTop := gvQuestionTop; // + TempHeight;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft + gvTrackBarIndent;
      if Left < gvTrackBarIndent then
        Left := gvTrackBarIndent;
      //Width := GetWidth(Display.DisplayMask);
      //if Width = DEFAULT_EDIT_BOX_WIDTH then
      Width := WhichScrollBox.Width - gvScrollBarWidthWS - (2 * Left);
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      LabelsLeftTop := 30;
      Height := GUI_Control.GetTrackHeight(Font);
      ShowHint := True;
      Hint := HintIn;
      LineSize := 1;
      PageSize := 1;
      Labels := True;
      LabelsInterval := 1;
      //LabelsLeftTop := Height - (Height div 3);
      Min := MinIn;
      Max := MaxIn;
      gvQuestionTop := gvQuestionTop + Height;
    end;
end;

procedure Build_Date(ThisDate: TJvDatePickerEdit; aAnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);
begin

  with ThisDate do
    begin
      Parent := WhichScrollBox;
      AutoSelect := True;
      AlwaysReturnEditDate := false;
      AutoSize := False;
      AllowNoDate := True;
      NoDateText := '';
      DirectInput := True;
      EnableValidation := True; // Handles 1/1/1900 to 01/01/1900 & 1/1/03 to 01/01/2003
      StoreDate := False;
      StoreDateFormat := False;
      ShowCheckBox := false;
      ShowButton := true;
      OEMConvert := False;
      HideSelection := True;

      Name := cDate + IntToStr(gvQuestionOrder);

      if Piece(aAnswerDisplay.displaymask, DELIMITER, 2) = 'NOW' then
        Date := now
      else
        Date := StrToDate(Piece(aAnswerDisplay.displaymask, DELIMITER, 2));

      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Top := gvQuestionTop;
      if gvUseDesignFont then
        Font.Assign(aAnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Width := GetWidth(aAnswerDisplay.DisplayMask);
      if (Width = DEFAULT_EDIT_BOX_WIDTH) or
        (Width = 0) then
        Width := GUI_Control.TextWidth('XXXX\XX\XXXXXX', Font);
      Left := aAnswerDisplay.DisplayLeft;

      Height := GUI_Control.GetStandardHeight(Font);
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;

      if (not aAnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;

    end;
end;

procedure Build_Edit(Edit: TEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);
begin
  with Edit do
    begin
      Parent := WhichScrollBox;
      Name := cEdit + IntToStr(gvQuestionOrder);
      Tag := TagIn; //This is Question.ID
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Height := GUI_Control.GetStandardHeight(Font);
      Width := GetWidth(AnswerDisplay.DisplayMask);
      if (Width = DEFAULT_EDIT_BOX_WIDTH) or
        (Width = 0) then
        Width := 3 * gvDefaultEditWidth div 2;
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;
      Text := '';

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_MaskEdit(MaskEdit: TMaskEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);
begin
  with MaskEdit do
    begin
      Parent := WhichScrollBox;
      Name := cMaskEdit + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;

      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);

      PasswordChar := #0; // Allows text to seen
      EditMask := Piece(AnswerDisplay.DisplayMask, DELIMITER, 1);

      Width := GUI_Control.TextWidth(EditMask + 'XX', Font);
      Height := GUI_Control.GetStandardHeight(Font);
      BorderStyle := bsSingle;
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;

    end;
end;

procedure Build_Currency(Currency: TJvValidateEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn, aMin, aMax: integer; WhichScrollBox: TScrollBox);
begin
  with Currency do
    begin
      Parent := WhichScrollBox;
      Name := cCurrency + IntToStr(gvQuestionOrder);
      AutoSize := False;
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;
      Width := GetWidth(AnswerDisplay.DisplayMask);
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Height := GUI_Control.GetStandardHeight(Font);
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;

      ReadOnly := False;
      DisplayFormat := dfCurrency;
      ZeroEmpty := true;
      HasMinValue := true;
      HasMaxValue := true;
      MinValue := aMin;
      MaxValue := aMax;

      Alignment := AnswerDisplay.DisplayAlignment;

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_SpinEdit(SpinEdit: TRzSpinEdit; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn, aMin, aMax: integer; WhichKind: TResponseType; WhichScrollBox: TScrollBox);
// Presently the only type of WhichKind is "rtInteger," later there maybe "rtReal"
begin
  with SpinEdit do
    begin
      Parent := WhichScrollBox;
      Name := cSpinEdit + IntToStr(gvQuestionOrder);
      AutoSize := False;
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;
      Width := GetWidth(AnswerDisplay.DisplayMask);
      if gvUseDesignFont then
        Font.Assign(AnswerDisplay.DisplayFont)
      else
        Font.Assign(gvFont);
      Height := GUI_Control.GetStandardHeight(Font);
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;

      ReadOnly := False;
      AllowKeyEdit := True;
      //Alignment := Display.AnswerAlignment;
      Alignment := taLeftJustify;
      AllowBlank := True;
      AutoSelect := True;
      Min := aMin;
      Max := aMax;
//      if (0 > MinValue) and (0 < MaxValue) then
//        Value := 0
//      else
//        Value := MinValue;
      Text := Piece(AnswerDisplay.DisplayMask, DELIMITER, 2);

      if WhichKind <> rtInteger then
        begin
          IntegersOnly := false;
          Decimals := 2;
          Increment := 1;
        end
      else
        begin
          IntegersOnly := True;
          Decimals := 0;
          Increment := 1;
        end;
      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;
      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_Memo(MemoIn: TMemo; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox);
begin
  with MemoIn do
    begin
      Parent := WhichScrollBox;
      Name := cMemo + IntToStr(gvQuestionOrder);
      Tag := TagIn;
      TabStop := True;
      TabOrder := gvQuestionOrder;
      ShowHint := True;
      Hint := HintIn;
      Color := clWindow;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;

      if gvUseDesignFont then
        begin
          Font.Assign(AnswerDisplay.DisplayFont);
          Width := GetWidth(AnswerDisplay.DisplayMask);
          if (Width = DEFAULT_EDIT_BOX_WIDTH) or
            (Width = 0) then
            Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end
      else
        begin
          Font.Assign(gvFont);
          Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;
        end;

      Height := GUI_Control.GetMemoHeight(Font);
      WordWrap := True;
      WantTabs := false;
      WantReturns := True;
      ScrollBars := ssVertical;
      ReadOnly := False;

      if (not AnswerDisplay.DisplaySameLine) or
        (not gvUseDesignFont) then // next line
        begin
          gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
          Exit;
        end;

      if TempHeight > Height then
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + TempHeight
      else
        gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;
    end;
end;

procedure Build_ScrollBox(ScrollBoxIn: TScrollBox; aParent: TForm);
begin
  with ScrollBoxIn do
    begin
      Parent := aParent; //frmID_Main;
      Name := 'sb' + IntToStr(gvInstrumentNumber);

      TabStop := false;
      TabOrder := 0;
      ShowHint := False;
      Color := clBtnFace;
      ParentColor := True;
      ParentFont := True;
      HorzScrollBar.Visible := True;
      VertScrollBar.Visible := True;
      Visible := True;
      Align := alClient;
      AutoScroll := True;
      BevelInner := bvNone;
      BevelKind := bkNone;
      BevelOuter := bvNone;
      BorderStyle := bsNone;
      Enabled := True;
    end;
end;

function Build_508IntroCaption(GroupBoxIn: TGroupBox;
  Display: TDisplay;
  StringIn: string;
  TagIn: Integer;
  AResponseType: TResponseType;
  WhichScrollBox: TScrollBox): integer;

begin

  with GroupBoxIn do
    begin
      Parent := WhichScrollBox;
      Name := cGrpBox + IntToStr(gvQuestionOrder);
      TabStop := True;
      TabOrder := gvQuestionOrder;
      ShowHint := false;
      Tag := TagIn;
      Top := gvQuestionTop;
      Left := 1;
      Font.Name := 'MS Serif';
      Font.Size := 7;
      //patch 108 508 changes llh - changed "key to continue" to "key to enter data"
      Caption := StringIn + ' Press tab key to enter data.';
      if (AResponseType = rtTrackBar) then
        Caption := StringIn + ' Press tab key to enter data. This item has gradiations between low and high values. Use arrow key to navigate. Select with enter key.';
      if (AResponseType = rtMultiChoice) then
        Caption := StringIn + ' Press tab key to enter data. Navigate with arrow keys. Select with enter key.';

      Width := GUI_Control.TextWidth(Caption + 'XXXXXXXXXX', Font); //1000;
      Height := GUI_Control.TextHeight('Yy', Font);
      Result := Height;
    end;
end;

procedure Build_Faux_TrackBar(ListBox: TListBox; AnswerDisplay: TDisplay;
  HintIn: string; TempHeight, TagIn: integer; WhichScrollBox: TScrollBox;
  AItems: TStringList);
// Used for 508 Track bar;
begin
  with ListBox do
    begin
      Parent := WhichScrollBox;
      Style := lbOwnerDrawFixed;
      Name := cListBox + IntToStr(gvQuestionOrder);
      TabStop := True;
      TabOrder := gvQuestionOrder;
      Tag := TagIn;
      Top := gvQuestionTop;
      Left := AnswerDisplay.DisplayLeft;

      Font.Assign(gvFont);
      Width := WhichScrollBox.Width - gvScrollBarWidthWS - Left;

      ShowHint := True;
      Hint := HintIn;
      BorderStyle := bsSingle;
      Color := clWindow;
      Sorted := False;
      MultiSelect := False;
      IntegralHeight := false;
      ItemIndex := -1;
      ItemHeight := GUI_Control.GetItemHeight(Font);

      Items.AddStrings(AItems);
      Columns := 1;

      Height := GUI_Control.HeightListBox(Width, Columns, Font,
        AItems);

      gvQuestionTop := gvQuestionSpace + gvQuestionTop + Height;

    end;
end;

end.

