unit uIA_ThisUser;

interface

uses
  Trpcb;

type
  // Do not use "User" for the name of this object. The RPC Broker uses
  // that name for an object.
  TThisUser = class
  private
    FName,
      FStationCode,
      FStationSuffix,
      FAccessKeys,
      FDUZ: string;
  protected
  public
  //published
    property Name: string read FName write FName;
    property DUZ: string read FDUZ write FDUZ;
    property AccessKeys: string read FAccessKeys write FAccessKeys;
    property StationCode: string read FStationCode write FStationCode;
    property StationSuffix: string read FStationSuffix write FStationSuffix;
    procedure Load(aDUZ: string; Broker: TRPCBroker);
    function CosignerNeeded(aDUZ, ProgNoteTitle: string;
      Broker: TRPCBroker): Boolean;
  end; { TThisUser }

var
  ThisUser                    : TThisUser;

implementation

uses
  uIA_Const,
  fIA_dialogs,
  uIA_Utils,
  uIA_ThisUser_IO;


procedure TThisUser.Load(aDUZ: string; Broker: TRPCBroker);
// Information about user returned
var
  TempStr, TempDUZ            : string;
begin
  FStationCode := '';
  FStationSuffix := '';

  TempDUZ := aDUZ;
  TempStr := ReadUserProperties(TempDUZ, Broker);

  // TempStr returns:
  //  MHPROVIDER,ONE^5325^^Station Code^Station Name^Station Suffix^^^no title sent^
  
  FName := Piece(TempStr, U, 1);
  FDUZ := Piece(TempStr, U, 2);
  FStationCode := Piece(TempStr, U, 4);
  FStationSuffix := Piece(TempStr, U, 6);

  FAccessKeys := ReadUserPermissions(TempDUZ, Broker);
  // Returns: YSP^YSPROG
  // No keys, returns blank.

end;

function TThisUser.CosignerNeeded(aDUZ, ProgNoteTitle: string;
      Broker: TRPCBroker): Boolean;
// Default is false
begin
  result := ReadCosigner(aDUZ, ProgNoteTitle, Broker);
end;



initialization
  ThisUser := TThisUser.Create;

finalization
  ThisUser.Free;

end.

